import React from 'react';
import { MwFormField, MwFormProps, RegisterFieldProps } from './mw-form';
import { MwSearchField } from '../MwSearch/mw-search';
import { AnyKeyProps } from '../types/AnyKeyProps';
import 'moment/locale/zh-cn';
import { MwSearchTableField } from '../MwSearchTable/mw-search-table';
/**
 * 注册一个 field type
 * @param fieldType field 类型
 * @param field 注册的 field
 */
export declare const registerField: (fieldType: string, field: RegisterFieldProps) => void;
/**
 * 获得配置列表
 * @param fields 配置列表
 */
export declare const getDefaultValue: (fields: Array<MwFormField | MwSearchField | MwSearchTableField>) => AnyKeyProps;
export declare const getFieldDefaultValue: (key: string, fields: Array<MwFormField | MwSearchField | MwSearchTableField>) => any;
/**
 * antd form 原生支持的方法尽数暴露出去
 */
export declare const funcs: string[];
declare const _default: React.ForwardRefExoticComponent<Omit<MwFormProps, "ref"> & React.RefAttributes<any>>;
export default _default;
