/// <reference types="react" />
import MwButton, { setPermissionList } from './MwButton';
import MwAction, { registerAction } from './MwAction';
import MwCtrl from './MwCtrl';
import MwCard from './MwCard';
import MwDialog, { setGlobalDialogField } from './MwDialog';
import MwDialogForm from './MwDialogForm';
import MwForm, { registerField } from './MwForm';
import { success, info, error, warning } from './MwMessage';
import MwSearch, { setSearchDefaultVisibleRow } from './MwSearch';
import MwSearchTable, { setSearchTableDefaultValue } from './MwSearchTable';
import MwSelect from './MwSelect';
import MwTable, { setDefaultDataFilter, setDefaultSearchFilter, registerTableRender, setTableDefaultProps } from './MwTable';
import MwFields from './MwFields';
import MwField from './MwField';
import MwSearchList from './MwSearchList';
import MwCardGroup from './MwCardGroup';
import MwTagGroup from './MwTagGroup';
import { setLanguage } from './locale';
import useOptions from './hooks/useOptions';
export { MwCard, MwCardGroup, MwTagGroup, MwAction, registerAction, MwButton, setPermissionList, MwCtrl, MwDialog, MwDialogForm, MwForm, registerField, MwSearch, setSearchDefaultVisibleRow, MwSearchTable, MwSelect, MwTable, MwFields, MwField, MwSearchList, useOptions, setDefaultDataFilter, setDefaultSearchFilter, setGlobalDialogField, setSearchTableDefaultValue, setTableDefaultProps, registerTableRender, success, info, error, warning, setLanguage };
declare const _default: {
    MwCard: typeof MwCard;
    MwCardGroup: typeof MwCardGroup;
    MwTagGroup: typeof MwTagGroup;
    MwAction: typeof MwAction;
    registerAction: (actionName: string, action: (props: import("./types/AnyKeyProps").AnyKeyProps, record: import("./types/AnyKeyProps").AnyKeyProps, searchTable: import("./types/AnyKeyProps").AnyKeyProps, form?: import("./types/AnyKeyProps").AnyKeyProps | undefined) => import("./types/AnyKeyProps").AnyKeyProps) => void;
    MwButton: typeof MwButton;
    setPermissionList: (list: string[]) => void;
    MwCtrl: typeof MwCtrl;
    MwDialog: typeof MwDialog;
    MwDialogForm: import("react").ForwardRefExoticComponent<import("./MwDialogForm/mw-dialog-form").MwDialogFormProps & import("react").RefAttributes<import("./MwDialogForm/mw-dialog-form").MwDialogFormRef>>;
    MwForm: import("react").ForwardRefExoticComponent<Omit<import("./MwForm/mw-form").MwFormProps, "ref"> & import("react").RefAttributes<any>>;
    registerField: (fieldType: string, field: import("./MwForm/mw-form").RegisterFieldProps) => void;
    MwSearch: import("react").ForwardRefExoticComponent<Omit<import("./MwSearch/mw-search").MwSearchProps, "ref"> & import("react").RefAttributes<unknown>>;
    setSearchDefaultVisibleRow: (row: number) => void;
    MwSearchTable: import("react").ForwardRefExoticComponent<Omit<import("./MwSearchTable/mw-search-table").MwSearchTableProps, "ref"> & import("react").RefAttributes<any>>;
    MwSelect: import("react").ForwardRefExoticComponent<import("./MwSelect/mw-select").MwSelectProps & import("react").RefAttributes<unknown>>;
    MwTable: import("react").ForwardRefExoticComponent<import("./MwTable/mw-table").MwTableProps & import("react").RefAttributes<unknown>>;
    MwFields: typeof MwFields;
    MwField: typeof MwField;
    MwSearchList: import("react").ForwardRefExoticComponent<Omit<import("./MwSearchList/mw-search-list").MwSearchListProps, "ref"> & import("react").RefAttributes<any>>;
    useOptions: typeof useOptions;
    setDefaultDataFilter: (cb: (params: import("./types/AnyKeyProps").AnyKeyProps) => import("./types/AnyKeyProps").AnyKeyProps) => void;
    setDefaultSearchFilter: (cb: (params: import("./types/AnyKeyProps").AnyKeyProps) => import("./types/AnyKeyProps").AnyKeyProps) => void;
    setSearchTableDefaultValue: (config: import("./MwSearchTable/mw-search-table").SearchTableInitConfig) => void;
    setTableDefaultProps: (props: import("./types/AnyKeyProps").AnyKeyProps) => void;
    registerTableRender: (key: string, render: (props: import("./MwTable/mw-table").RenderProps) => import("react").ReactNode) => void;
    success: (msg: import("react").ReactNode, duration?: number | undefined) => import("antd/lib/message").MessageType;
    info: (msg: import("react").ReactNode, duration?: number | undefined) => import("antd/lib/message").MessageType;
    error: (msg: import("react").ReactNode, duration?: number | undefined) => import("antd/lib/message").MessageType;
    warning: (msg: import("react").ReactNode, duration?: number | undefined) => import("antd/lib/message").MessageType;
    setLanguage: (lang: string) => void;
};
export default _default;
