import React from 'react';
import { AnyKeyProps } from './types/AnyKeyProps';
import { Option } from './MwForm/mw-form';
/**
 * 拷贝对象
 * @param obj
 */
export declare const copy: (obj: AnyKeyProps) => any;
/**
 * 获取随机数
 * @param min 最小随机数
 * @param max 最大随机数
 */
export declare const getRandom: (min: number, max: number) => number;
/**
 * 获取随机数（带小数）
 * @param min 最小随机数
 * @param max 最大随机数
 */
export declare const getRandomFloor: (min: number, max: number) => number;
/**
 * 是否是对象
 * @param obj 判断对象
 */
export declare const isObj: (obj: any) => boolean;
/**
 * 是否是方法
 * @param func 判断对象
 */
export declare const isFunc: (func: any) => boolean;
/**
 * 清空对象的 undefined 和 null
 * @param params 要清空的对象
 */
export declare const clearEmpty: (params: AnyKeyProps) => AnyKeyProps;
interface ListToTreeProps {
    /** 数据源 */
    data: Array<AnyKeyProps>;
    /** 父节点 key */
    parentKey?: string;
    /** 标题 key */
    labelKey?: string;
    /** 子节点 key */
    childrenKey?: string;
    /** 值 key */
    valueKey?: string;
    /** 跟节点值 */
    rootValue?: string | null;
    /** 是否拥有 children */
    keepLeaf?: boolean;
}
/**
 * 列表转树结构
 * @param props 配置参数
 */
export declare const listToTree: (props: ListToTreeProps) => AnyKeyProps[];
export declare const getLabelByValue: (type: number | undefined, options: AnyKeyProps) => any;
/**
 * 数字转金额
 * @param value 金额
 */
export declare const getCurrencyValue: (value: any) => string;
/**
 * 通过选项列表把 value 变成 label
 * @param value 当前值
 * @param options 选项列表
 */
export declare const getValueByOptions: (value: any, options: Array<Option>) => any;
/**
 * 输出 YYYY-MM-DD 格式
 * @param value
 */
/**
 * @desc渲染一个带颜色的状态
 *
 * @param status 状态值
 * @param options 选项
 *
 * @returns ReactNode
 */
export declare const renderStatus: (status: string | number, options: Option[], type?: 'badge' | 'tag') => string | number | true | React.ReactFragment | JSX.Element;
/**
 * 复制一个对象，只选择其中某些 key
 * @param obj 复制对象
 * @param key 要保留的 key，可以是数组
 * @returns 保留了 key 的对象
 */
export declare const optionObj: (obj: AnyKeyProps, key: string | Array<string>) => AnyKeyProps;
/**
 * 复制一个对象，并删除某些 key
 * @param obj 复制对象
 * @param key 要删除的 key，可以是数组
 * @returns 删除了 key 的对象
 */
export declare const omitObj: (obj: AnyKeyProps, key: string | Array<string>) => {
    [x: string]: any;
};
/**
 * 根据行获取 rowKey，默认取 id
 * @param record 当前行
 * @param rowKey
 * @returns
 */
export declare const getRowKey: (record: AnyKeyProps, rowKey?: string | ((item: AnyKeyProps) => React.Key) | undefined) => React.Key;
/**
 * 根据 rowKey 获取行的 key
 * @param record 当前行
 * @param rowKey
 * @returns
 */
export declare const getKey: (record: AnyKeyProps, rowKey?: string | ((item: AnyKeyProps) => React.Key) | undefined) => any;
declare const _default: {};
export default _default;
