var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __generator = this && this.__generator || function (thisArg, body) {
  var _ = {
      label: 0,
      sent: function sent() {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
var __spreadArray = this && this.__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useContext, useState } from 'react';
import MwButton from '../MwButton';
import { MwSearchTableContext } from '../MwSearchTable/context';
import { success, info } from '../MwMessage';
import { Modal } from 'antd';
import { EditableContext } from '../MwTable/context';
import { PlusOutlined, DeleteOutlined, ExclamationCircleOutlined } from '@ant-design/icons';
import locale from '../locale';
import { getKey, getRowKey } from '../utils';
export var actionMap = {};
/**
 * 注册一个 action
 */
export var registerAction = function registerAction(actionName, action) {
  actionMap[actionName] = action;
};
/**
 * 注册【新增】事件
 */
registerAction('add', function (props, record, searchTable) {
  return __assign({
    type: 'primary',
    icon: /*#__PURE__*/React.createElement(PlusOutlined, null),
    onClick: function onClick() {
      var _a, _b;
      if (props.onOpen) {
        var result = props.onOpen(record);
        if (result === false) {
          return;
        }
      }
      (_b = (_a = searchTable.formRef) === null || _a === void 0 ? void 0 : _a.current) === null || _b === void 0 ? void 0 : _b.add(__assign(__assign({}, props.params), record), __assign({
        onSuccess: function onSuccess(res) {
          success(props.successMsg || props.children + locale.action.success);
          searchTable.tableRef.current.refresh();
          // 请求完成回调
          if (props.onFinish) {
            props.onFinish(res);
          }
        }
      }, props.dialogformextend));
    }
  }, props);
});
/**
 * 注册【修改】事件
 */
registerAction('update', function (props, record, searchTable) {
  var _a = useState(false),
    loading = _a[0],
    setLoading = _a[1];
  return __assign({
    onClick: function onClick() {
      var _a, _b;
      if (props.onOpen) {
        var result = props.onOpen(record);
        if (result === false) {
          return;
        }
      }
      var extraParams = __assign({
        onSuccess: function onSuccess(res) {
          success(props.successMsg || props.children + locale.action.success);
          searchTable.tableRef.current.refresh();
          // 请求完成回调
          if (props.onFinish) {
            props.onFinish(res);
          }
        }
      }, props.dialogformextend);
      if (props.detailApi) {
        setLoading(true);
        props.detailApi(props.detailParams).then(function (res) {
          var _a, _b;
          (_b = (_a = searchTable.formRef) === null || _a === void 0 ? void 0 : _a.current) === null || _b === void 0 ? void 0 : _b.update(props.detailApiFilter ? props.detailApiFilter(res) : res.data, extraParams);
        }).finally(function () {
          setLoading(false);
        });
      } else {
        (_b = (_a = searchTable.formRef) === null || _a === void 0 ? void 0 : _a.current) === null || _b === void 0 ? void 0 : _b.update(__assign(__assign({}, props.params), record), extraParams);
      }
    },
    loading: loading
  }, props);
});
/**
 * 注册【详情】事件
 */
registerAction('view', function (props, record, searchTable) {
  var _a = useState(false),
    loading = _a[0],
    setLoading = _a[1];
  return __assign({
    onClick: function onClick() {
      var _a, _b;
      if (props.onOpen) {
        var result = props.onOpen(record);
        if (result === false) {
          return;
        }
      }
      if (props.detailApi) {
        setLoading(true);
        props.detailApi(props.detailParams).then(function (res) {
          var _a, _b;
          (_b = (_a = searchTable.formRef) === null || _a === void 0 ? void 0 : _a.current) === null || _b === void 0 ? void 0 : _b.view(props.detailApiFilter ? props.detailApiFilter(res) : res.data);
        }).finally(function () {
          setLoading(false);
        });
      } else {
        (_b = (_a = searchTable.formRef) === null || _a === void 0 ? void 0 : _a.current) === null || _b === void 0 ? void 0 : _b.view(__assign(__assign({}, props.params), record));
      }
    },
    loading: loading
  }, props);
});
/**
 * 注册【删除】事件
 */
registerAction('delete', function (props, record, searchTable) {
  return __assign({
    confirm: true,
    confirmMsg: locale.action.deleteConfirm,
    onConfirm: function onConfirm() {
      if ((searchTable === null || searchTable === void 0 ? void 0 : searchTable.deleteApi) && record) {
        var params_1 = [getKey(record, searchTable === null || searchTable === void 0 ? void 0 : searchTable.rowKey)];
        searchTable === null || searchTable === void 0 ? void 0 : searchTable.deleteApi(params_1).then(function (data) {
          success(props.successMsg || locale.action.deleteSuccess);
          searchTable === null || searchTable === void 0 ? void 0 : searchTable.tableRef.current.refresh();
          // 请求完成回调
          if (props.onFinish) {
            props.onFinish({
              data: data,
              params: params_1
            });
          }
        });
      }
    }
  }, props);
});
/**
 * 注册【批量删除】事件
 */
registerAction('batch-delete', function (props, _record, searchTable) {
  return __assign({
    icon: /*#__PURE__*/React.createElement(DeleteOutlined, null),
    tableFooterExtraOnly: true,
    onClick: function onClick() {
      var selection = (searchTable === null || searchTable === void 0 ? void 0 : searchTable.selection) || [];
      if (!selection.length) {
        info(locale.action.noSelection);
        return;
      }
      if (searchTable === null || searchTable === void 0 ? void 0 : searchTable.deleteApi) {
        Modal.confirm({
          title: locale.action.deleteConfirmTitle,
          content: "".concat(locale.action.deleteConfirmBefore, " ").concat(selection.length, " ").concat(locale.action.deleteConfirmAfter),
          icon: /*#__PURE__*/React.createElement(ExclamationCircleOutlined, null),
          onOk: function onOk() {
            var params = selection.map(function (row) {
              return getKey(row, searchTable === null || searchTable === void 0 ? void 0 : searchTable.rowKey);
            });
            searchTable === null || searchTable === void 0 ? void 0 : searchTable.deleteApi(params).then(function (data) {
              success(props.successMsg || locale.action.deleteConfirmBatchSuccess);
              searchTable === null || searchTable === void 0 ? void 0 : searchTable.clearSelection();
              searchTable === null || searchTable === void 0 ? void 0 : searchTable.tableRef.current.refresh();
              // 请求完成回调
              if (props.onFinish) {
                props.onFinish({
                  data: data,
                  params: params
                });
              }
            });
          }
        });
      }
    }
  }, props);
});
/**
 * 注册【可编辑表格】【编辑】事件
 */
registerAction('editable-update', function (props, record, searchTable) {
  return __assign({
    onClick: function onClick() {
      if (record) {
        // 将表单数据与行数据合并
        var newRow_1 = __assign(__assign({}, record), {
          editing: true
        });
        // @ts-ignore 重新构建数组
        var newTableData = __spreadArray([], searchTable.tableRef.current.getTableData(), true);
        // 寻找到对应行
        var index = newTableData.findIndex(function (row) {
          return getKey(row, searchTable === null || searchTable === void 0 ? void 0 : searchTable.rowKey) === getKey(newRow_1, searchTable === null || searchTable === void 0 ? void 0 : searchTable.rowKey);
        });
        // 替换行
        newTableData.splice(index, 1, newRow_1);
        // 替换表格数据
        searchTable.tableRef.current.setTableData(newTableData);
      }
    }
  }, props);
});
/**
 * 注册【可编辑表格】【确定】事件
 */
registerAction('editable-confirm', function (props, record, searchTable, form) {
  return __assign({
    onClick: function onClick() {
      return __awaiter(void 0, void 0, void 0, function () {
        var values, newRow_2, newTableData, index;
        return __generator(this, function (_a) {
          switch (_a.label) {
            case 0:
              if (!(record && form)) return [3 /*break*/, 2];
              return [4 /*yield*/, form.validateFields()
              // 将表单数据与行数据合并
              ];

            case 1:
              values = _a.sent();
              newRow_2 = __assign(__assign({}, record), values);
              // 取消编辑模式
              delete newRow_2.editing;
              // 删除新增标识
              delete newRow_2._isNew;
              newTableData = __spreadArray([], searchTable.tableRef.current.getTableData(), true);
              index = newTableData.findIndex(function (row) {
                return getKey(row, searchTable === null || searchTable === void 0 ? void 0 : searchTable.rowKey) === getKey(newRow_2, searchTable === null || searchTable === void 0 ? void 0 : searchTable.rowKey);
              });
              // 替换行
              newTableData.splice(index, 1, newRow_2);
              // 替换表格数据
              searchTable.tableRef.current.setTableData(newTableData);
              _a.label = 2;
            case 2:
              return [2 /*return*/];
          }
        });
      });
    }
  }, props);
});
/**
 * 注册【可编辑表格】【取消】事件
 */
registerAction('editable-cancel', function (props, record, searchTable) {
  return __assign({
    onClick: function onClick() {
      if (record) {
        // 将表单数据与行数据合并
        var newRow_3 = __assign(__assign({}, record), {
          editing: false
        });
        // @ts-ignore 重新构建数组
        var newTableData = __spreadArray([], searchTable.tableRef.current.getTableData(), true);
        // 寻找到对应行
        var index = newTableData.findIndex(function (row) {
          return getKey(row, searchTable === null || searchTable === void 0 ? void 0 : searchTable.rowKey) === getKey(newRow_3, searchTable === null || searchTable === void 0 ? void 0 : searchTable.rowKey);
        });
        if (record._isNew) {
          // 删除新增行
          newTableData.splice(index, 1);
        } else {
          // 替换行
          newTableData.splice(index, 1, newRow_3);
        }
        // 替换表格数据
        searchTable.tableRef.current.setTableData(newTableData);
      }
    }
  }, props);
});
/**
 * 注册【可编辑表格】【删除】事件
 */
registerAction('editable-delete', function (props, record, searchTable) {
  return __assign({
    confirm: true,
    confirmMsg: locale.action.deleteConfirm,
    onConfirm: function onConfirm() {
      var key = getKey(record, searchTable === null || searchTable === void 0 ? void 0 : searchTable.rowKey);
      searchTable.tableRef.current.deleteRowByKey(key);
      props.callback && props.callback(key);
    }
  }, props);
});
/**
 * 注册【可编辑表格】【新增】事件
 */
registerAction('editable-add', function (props, _record, searchTable) {
  return __assign({
    icon: /*#__PURE__*/React.createElement(PlusOutlined, null),
    type: 'dashed',
    block: true,
    style: {
      marginTop: 8,
      marginBottom: 8
    },
    onClick: function onClick() {
      var _a;
      searchTable.tableRef.current.addRow((_a = {}, _a[getRowKey({}, searchTable === null || searchTable === void 0 ? void 0 : searchTable.rowKey)] = Date.now(),
      // 正在编辑
      _a.editing = true,
      // 新增标识
      _a._isNew = true, _a));
    }
  }, props);
});
/**
 * 获得转换后 action props
 * @param props 当前 props
 * @param searchTable searchTable 对象
 */
export var getActionProps = function getActionProps(props, searchTable, form) {
  var action = props.action,
    record = props.record;
  var targetAction = actionMap[action || ''];
  if (targetAction) {
    var actionProps = targetAction(props, record, searchTable, form);
    return actionProps;
  }
  return props;
};
export default function MwAction(props) {
  var searchTable = useContext(MwSearchTableContext);
  var form = useContext(EditableContext);
  var actionProps = getActionProps(props, searchTable, form);
  return /*#__PURE__*/React.createElement(MwButton, __assign({}, actionProps));
}
MwAction.componentName = 'MwAction';