var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import React, { useState, useEffect } from 'react';
import { Button, Popconfirm, Modal, Tooltip } from 'antd';
import classNames from 'classnames';
import { omitObj } from '../utils';
var refreshList = [];
export var addRefresh = function addRefresh(setRefresh) {
  refreshList.push(setRefresh);
};
export var removeRefresh = function removeRefresh(setRefresh) {
  var refreshIndex = refreshList.findIndex(function (item) {
    return item === setRefresh;
  });
  if (refreshIndex >= 0) {
    refreshList.splice(refreshIndex, 1);
  }
};
// 权限列表
var permissionList = [];
export var setPermissionList = function setPermissionList(list) {
  permissionList = list;
  refreshList.forEach(function (setRefresh) {
    setRefresh(Math.random());
  });
};
export var hasPermission = function hasPermission(permission) {
  if (!permission) {
    return true;
  }
  if (permissionList.includes(permission)) {
    return true;
  }
  return false;
};
var keys = ['confirm', 'onConfirm', 'confirmMsg', 'tableFooterExtraOnly', 'action', 'api', 'onFinish', '__simple', 'deleteApi', 'detailApi', 'detailParams', 'detailApiFilter', 'permission', 'extra', 'record', 'confirmVisible', 'sub', 'omitKeys'];
export default function MwButton(props) {
  var _a = useState(0),
    setRefresh = _a[1];
  var params = __assign({}, props);
  useEffect(function () {
    addRefresh(setRefresh);
    return function () {
      removeRefresh(setRefresh);
    };
  }, []);
  // 权限控制
  if (params.permission && !permissionList.includes(params.permission)) {
    return null;
  }
  // 控制样式
  var className = ["mw-button"];
  // 是否在折叠按钮里面
  if (props.__simple) {
    className.push('simple');
  }
  // 是否是次级按钮
  if (props.sub) {
    className.push('sub');
  }
  // 是否有自定义样式
  if (props.className) {
    className.push(props.className);
  }
  className = classNames(className);
  // 删除一些没有用到的属性
  if (props.omitKeys) {
    params = omitObj(params, props.omitKeys);
  }
  params = omitObj(params, keys);
  // 基础按钮
  var btn = /*#__PURE__*/React.createElement(Button, __assign({
    className: className
  }, params), props.children);
  // 带悬浮提示
  if (props.tooltip) {
    btn = /*#__PURE__*/React.createElement(Tooltip, {
      title: props.tooltip
    }, btn);
  }
  // 带确认提示
  if (props.confirm && !props.disabled) {
    if (!props.__simple) {
      return /*#__PURE__*/React.createElement(Popconfirm, {
        title: props.confirmMsg,
        onConfirm: function onConfirm() {
          return props.onConfirm && props.onConfirm();
        }
      }, btn);
    } else {
      return /*#__PURE__*/React.createElement(Button, __assign({
        className: className
      }, params, {
        onClick: function onClick() {
          Modal.confirm({
            content: props.confirmMsg,
            onOk: function onOk() {
              return props.onConfirm && props.onConfirm();
            }
          });
        }
      }), props.children);
    }
  }
  return btn;
}
MwButton.componentName = 'MwButton';