var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import React, { useEffect, useState } from 'react';
import { Card } from 'antd';
import { DownOutlined } from '@ant-design/icons';
export default function MwCard(props) {
  var collapsible = props.collapsible,
    onCollapse = props.onCollapse,
    defaultCollapsed = props.defaultCollapsed,
    children = props.children,
    title = props.title,
    extra = props.extra,
    _a = props.collapsePosition,
    collapsePosition = _a === void 0 ? 'extra' : _a;
  var _b = useState(props.collapsed || defaultCollapsed || false),
    collapsed = _b[0],
    setCollapsed = _b[1];
  var params = __assign({}, props);
  delete params.collapsible;
  delete params.defaultCollapsed;
  delete params.collapsePosition;
  delete params.collapsed;
  delete params.onCollapse;
  useEffect(function () {
    setCollapsed(props.collapsed || false);
  }, [props.collapsed]);
  var toggleCollapsed = function toggleCollapsed() {
    setCollapsed(!collapsed);
    if (onCollapse) {
      onCollapse(!collapsed);
    }
  };
  var icon = collapsible ? /*#__PURE__*/React.createElement(DownOutlined, {
    className: "mw-card-collapsible-icon ".concat(collapsePosition),
    onClick: toggleCollapsed
  }) : null;
  return /*#__PURE__*/React.createElement(Card, __assign({}, params, {
    className: "mw-card ".concat(collapsed ? 'collapsed' : ''),
    title: title ? /*#__PURE__*/React.createElement(React.Fragment, null, collapsePosition === 'title' ? icon : null, title) : null,
    extra: title ? /*#__PURE__*/React.createElement(React.Fragment, null, extra, collapsePosition === 'extra' ? icon : null) : null
  }), children);
}