var __spreadArray = this && this.__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
import React from 'react';
import classNames from 'classnames';
import { FORM_DEFAULT_VALUE_CARD_GROUP } from '../constant';
import "./index.css";
var classPrefix = 'mw-card-group';
var getCoverNode = function getCoverNode(option, props) {
  var size = props.size;
  return option.cover ? /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(classPrefix, "-cover"), !option.label && !option.description && "".concat(classPrefix, "-no-info"))
  }, typeof option.cover === 'string' ? /*#__PURE__*/React.createElement("img", {
    src: option.cover,
    width: size === 'large' ? 48 : 24,
    height: size === 'large' ? 48 : 24,
    alt: "",
    draggable: false
  }) : option.cover) : null;
};
export default function MwCardGroup(props) {
  var _a = props.value,
    value = _a === void 0 ? [] : _a,
    onChange = props.onChange,
    options = props.options,
    _b = props.size,
    size = _b === void 0 ? 'default' : _b,
    readonly = props.readonly,
    _c = props.multiple,
    multiple = _c === void 0 ? false : _c,
    cardStyle = props.cardStyle,
    _d = props.cancelable,
    cancelable = _d === void 0 ? true : _d,
    className = props.className,
    style = props.style;
  var handleSelect = function handleSelect(option) {
    // 禁用和只读不处理
    if (option.disabled || readonly) {
      return;
    }
    if (multiple && Array.isArray(value)) {
      // 多选
      if (value.includes(option.value)) {
        triggerChange(value.filter(function (v) {
          return v !== option.value;
        }));
      } else {
        triggerChange(__spreadArray(__spreadArray([], value, true), [option.value], false));
      }
    } else {
      // 单选
      if (option.value === value) {
        if (cancelable) {
          triggerChange(FORM_DEFAULT_VALUE_CARD_GROUP);
        }
      } else {
        triggerChange(option.value);
      }
    }
  };
  var triggerChange = function triggerChange(value) {
    if (onChange) {
      onChange(value);
    }
  };
  return /*#__PURE__*/React.createElement("ul", {
    className: classNames(className, classPrefix, classPrefix + '-' + size, readonly && "".concat(classPrefix, "-readonly"), multiple && "".concat(classPrefix, "-multiple")),
    style: style
  }, (options || []).map(function (option) {
    return /*#__PURE__*/React.createElement("li", {
      className: classNames("".concat(classPrefix, "-option"), (multiple ? value.includes(option.value) : value === option.value) && "".concat(classPrefix, "-option-active"), option.description && "".concat(classPrefix, "-option-has-desc"), option.disabled === true && "".concat(classPrefix, "-option-disabled")),
      key: option.value,
      style: cardStyle,
      onClick: function onClick() {
        return handleSelect(option);
      }
    }, getCoverNode(option, props), (!!option.label || !!option.description) && /*#__PURE__*/React.createElement("div", {
      className: "".concat(classPrefix, "-info")
    }, !!option.label && /*#__PURE__*/React.createElement("div", {
      className: "".concat(classPrefix, "-title")
    }, option.label), !!option.description && /*#__PURE__*/React.createElement("div", {
      className: "".concat(classPrefix, "-desc")
    }, option.description)));
  }));
}