var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import { getValueByOptions } from '../utils';
import { Input, Switch, Checkbox, Radio, DatePicker, InputNumber, Rate, Slider } from 'antd';
import React from 'react';
import MwSelect from '../MwSelect';
import { FORM_DEFAULT_ALLOW_CLEAR, FORM_DEFAULT_VALUE_NUMBER, FORM_DEFAULT_VALUE_INPUT, FORM_DEFAULT_VALUE_PASSWORD, FORM_DEFAULT_VALUE_SELECT, FORM_DEFAULT_VALUE_SWITCH, FORM_DEFAULT_VALUE_CHECKBOX, FORM_DEFAULT_VALUE_CHECKBOX_GROUP, FORM_DEFAULT_VALUE_RADIO_GROUP, FORM_DEFAULT_VALUE_TEXTAREA, FORM_DEFAULT_VALUE_DATE, FORM_DEFAULT_VALUE_DATE_RANGE, FORM_DEFAULT_VALUE_EMPTY, FORM_DEFAULT_VALUE_PERCENT, FORM_DEFAULT_VALUE_SEARCH, FORM_TYPE_SWITCH, FORM_TYPE_CHECKBOX, FORM_TYPE_CHECKBOX_GROUP, FORM_TYPE_SELECT, FORM_TYPE_PASSWORD, FORM_TYPE_INPUT, FORM_TYPE_RADIO_GROUP, FORM_TYPE_DATE, FORM_TYPE_TEXTAREA, FORM_TYPE_DATE_RANGE, FORM_TYPE_EMPTY, FORM_TYPE_NUMBER, FORM_TYPE_PERCENT, FORM_TYPE_SEARCH, TEXTAREA_DEFAULT_MAXLENGTH, INPUT_DEFAULT_MAXLENGTH, NUMBER_DEFAULT_MIN, NUMBER_DEFAULT_MAX, PERCENT_DEFAULT_MAX, FORM_READONLY_EMPTY, FORM_TYPE_RATE, FORM_DEFAULT_VALUE_RATE, FORM_TYPE_SLIDER, FORM_DEFAULT_VALUE_SLIDER, FORM_TYPE_TAG_GROUP, FORM_DEFAULT_VALUE_TAG_GROUP, FORM_TYPE_CARD_GROUP, FORM_DEFAULT_VALUE_CARD_GROUP, FORM_TYPE_HTML, FORM_DEFAULT_VALUE_HTML } from '../constant';
import MwTagGroup from '../MwTagGroup';
import MwCardGroup from '../MwCardGroup';
import locale from '../locale';
export var install = function install(registerField) {
  // 注册输入框
  registerField(FORM_TYPE_INPUT, {
    type: FORM_TYPE_INPUT,
    defaultValue: FORM_DEFAULT_VALUE_INPUT,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly,
        getFieldValue = _a.getFieldValue;
      return readonly ? /*#__PURE__*/React.createElement("span", {
        className: "mw-form-text"
      }, getFieldValue(field.key) || FORM_READONLY_EMPTY) : /*#__PURE__*/React.createElement(Input, __assign({
        placeholder: "".concat(locale.form.pleaseInput).concat(field.title || '').concat(locale.form.pleaseInputAfter),
        disabled: readonly,
        maxLength: INPUT_DEFAULT_MAXLENGTH,
        allowClear: FORM_DEFAULT_ALLOW_CLEAR
      }, field.props));
    }
  });
  // 注册搜索框
  registerField(FORM_TYPE_SEARCH, {
    type: FORM_TYPE_SEARCH,
    defaultValue: FORM_DEFAULT_VALUE_SEARCH,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly,
        getFieldValue = _a.getFieldValue,
        formInstans = _a.formInstans;
      return readonly ? /*#__PURE__*/React.createElement("span", {
        className: "mw-form-text"
      }, getFieldValue(field.key) || FORM_READONLY_EMPTY) : /*#__PURE__*/React.createElement(Input.Search, __assign({
        placeholder: "".concat(locale.form.pleaseInput).concat(field.title || '').concat(locale.form.pleaseInputAfter),
        disabled: readonly,
        onPressEnter: function onPressEnter(e) {
          e.preventDefault();
          formInstans.submit();
        },
        onSearch: function onSearch() {
          return formInstans.submit();
        },
        maxLength: INPUT_DEFAULT_MAXLENGTH,
        allowClear: FORM_DEFAULT_ALLOW_CLEAR,
        enterButton: true
      }, field.props));
    }
  });
  // 注册数字框
  registerField(FORM_TYPE_NUMBER, {
    type: FORM_TYPE_NUMBER,
    defaultValue: FORM_DEFAULT_VALUE_NUMBER,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly,
        getFieldValue = _a.getFieldValue;
      return readonly ? /*#__PURE__*/React.createElement("span", {
        className: "mw-form-text"
      }, getFieldValue(field.key) || FORM_READONLY_EMPTY) : /*#__PURE__*/React.createElement(InputNumber, __assign({
        className: "max-width",
        disabled: readonly,
        min: NUMBER_DEFAULT_MIN,
        max: NUMBER_DEFAULT_MAX
      }, field.props));
    }
  });
  // 注册百分比数字框
  registerField(FORM_TYPE_PERCENT, {
    type: FORM_TYPE_PERCENT,
    defaultValue: FORM_DEFAULT_VALUE_PERCENT,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly,
        getFieldValue = _a.getFieldValue;
      return readonly ? /*#__PURE__*/React.createElement("span", {
        className: "mw-form-text"
      }, getFieldValue(field.key) || FORM_READONLY_EMPTY, "%") : /*#__PURE__*/React.createElement(InputNumber, __assign({
        className: "max-width",
        disabled: readonly,
        min: NUMBER_DEFAULT_MIN,
        max: PERCENT_DEFAULT_MAX,
        formatter: function formatter(value) {
          return value !== '' ? "".concat(value, "%") : '';
        },
        parser: function parser(value) {
          return (value || '').replace('%', '');
        }
      }, field.props));
    }
  });
  // 注册密码框
  registerField(FORM_TYPE_PASSWORD, {
    type: FORM_TYPE_PASSWORD,
    defaultValue: FORM_DEFAULT_VALUE_PASSWORD,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly,
        getFieldValue = _a.getFieldValue;
      return readonly ? /*#__PURE__*/React.createElement("span", {
        className: "mw-form-text"
      }, (getFieldValue(field.key) + '').replace(/./g, '*') || FORM_READONLY_EMPTY) : /*#__PURE__*/React.createElement(Input.Password, __assign({
        placeholder: "".concat(locale.form.pleaseInput).concat(field.title || '').concat(locale.form.pleaseInputAfter),
        disabled: readonly,
        allowClear: FORM_DEFAULT_ALLOW_CLEAR
      }, field.props));
    }
  });
  // 注册多行文本框
  registerField(FORM_TYPE_TEXTAREA, {
    type: FORM_TYPE_TEXTAREA,
    defaultValue: FORM_DEFAULT_VALUE_TEXTAREA,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly,
        getFieldValue = _a.getFieldValue;
      return readonly ? /*#__PURE__*/React.createElement("span", {
        className: "mw-form-text"
      }, getFieldValue(field.key) || FORM_READONLY_EMPTY) : /*#__PURE__*/React.createElement(Input.TextArea, __assign({
        placeholder: "".concat(locale.form.pleaseInput).concat(field.title || '').concat(locale.form.pleaseInputAfter),
        disabled: readonly,
        allowClear: FORM_DEFAULT_ALLOW_CLEAR,
        maxLength: TEXTAREA_DEFAULT_MAXLENGTH
      }, field.props));
    }
  });
  // 注册选择框
  registerField(FORM_TYPE_SELECT, {
    type: FORM_TYPE_SELECT,
    defaultValue: FORM_DEFAULT_VALUE_SELECT,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly,
        getFieldValue = _a.getFieldValue;
      if (readonly) {
        var value = getFieldValue(field.key);
        var text = '';
        if (Array.isArray(value)) {
          if (!value.length) {
            text = FORM_READONLY_EMPTY;
          }
          text = value.map(function (item) {
            return getValueByOptions(item, field.options);
          }).join(field.splitText || '、');
        } else {
          text = getValueByOptions(value, field.options);
        }
        return /*#__PURE__*/React.createElement("span", {
          className: "mw-form-text"
        }, text || FORM_READONLY_EMPTY);
      }
      return /*#__PURE__*/React.createElement(MwSelect, __assign({
        placeholder: "".concat(locale.form.pleaseSelect).concat(field.title || '').concat(locale.form.pleaseSelectAfter),
        disabled: readonly,
        allowClear: FORM_DEFAULT_ALLOW_CLEAR,
        options: field.options
      }, field.props));
    }
  });
  // 注册开关
  registerField(FORM_TYPE_SWITCH, {
    type: FORM_TYPE_SWITCH,
    defaultValue: FORM_DEFAULT_VALUE_SWITCH,
    valuePropName: 'checked',
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly;
      return /*#__PURE__*/React.createElement(Switch, __assign({
        disabled: readonly
      }, field.props));
    }
  });
  // 注册单个选择框
  registerField(FORM_TYPE_CHECKBOX, {
    type: FORM_TYPE_CHECKBOX,
    defaultValue: FORM_DEFAULT_VALUE_CHECKBOX,
    valuePropName: 'checked',
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly;
      return /*#__PURE__*/React.createElement(Checkbox, __assign({
        disabled: readonly
      }, field.props));
    }
  });
  // 注册多个选择框
  registerField(FORM_TYPE_CHECKBOX_GROUP, {
    type: FORM_TYPE_CHECKBOX_GROUP,
    defaultValue: FORM_DEFAULT_VALUE_CHECKBOX_GROUP,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly;
      return /*#__PURE__*/React.createElement(Checkbox.Group, __assign({
        disabled: readonly,
        options: field.options
      }, field.props));
    }
  });
  // 注册多个单选框
  registerField(FORM_TYPE_RADIO_GROUP, {
    type: FORM_TYPE_RADIO_GROUP,
    defaultValue: FORM_DEFAULT_VALUE_RADIO_GROUP,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly;
      return /*#__PURE__*/React.createElement(Radio.Group, __assign({
        disabled: readonly,
        options: field.options
      }, field.props));
    }
  });
  // 注册日期
  registerField(FORM_TYPE_DATE, {
    type: FORM_TYPE_DATE,
    defaultValue: FORM_DEFAULT_VALUE_DATE,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly,
        getFieldValue = _a.getFieldValue;
      var text = getFieldValue(field.key, readonly);
      if (typeof text !== 'string') {
        text = '';
      }
      return readonly ? /*#__PURE__*/React.createElement("span", {
        className: "mw-form-text"
      }, text || FORM_READONLY_EMPTY) : /*#__PURE__*/React.createElement(DatePicker, __assign({
        className: "max-width",
        placeholder: "".concat(locale.form.pleaseSelect).concat(field.title || '').concat(locale.form.pleaseSelectAfter)
      }, field.props));
    }
  });
  // 注册区间日期
  registerField(FORM_TYPE_DATE_RANGE, {
    type: FORM_TYPE_DATE_RANGE,
    defaultValue: FORM_DEFAULT_VALUE_DATE_RANGE,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly,
        getFieldValue = _a.getFieldValue;
      var text = getFieldValue(field.key, readonly);
      if (Array.isArray(text)) {
        if (text[0] === null) {
          text = null;
        } else if (text) {
          text = [/*#__PURE__*/React.createElement("span", {
            key: "start",
            style: {
              display: 'inline-block'
            }
          }, (text[0] || '').toString()), /*#__PURE__*/React.createElement("span", {
            key: "divider",
            style: {
              margin: '0 0.5em'
            }
          }, locale.form.dateTo), /*#__PURE__*/React.createElement("span", {
            key: "end",
            style: {
              display: 'inline-block'
            }
          }, (text[1] || '').toString())];
        }
      }
      return readonly ? /*#__PURE__*/React.createElement("span", {
        className: "mw-form-text"
      }, text || FORM_READONLY_EMPTY) : /*#__PURE__*/React.createElement(DatePicker.RangePicker, __assign({
        placeholder: [locale.form.startDate, locale.form.endDate],
        className: "max-width"
      }, field.props));
    }
  });
  // 注册空节点
  registerField(FORM_TYPE_EMPTY, {
    type: FORM_TYPE_EMPTY,
    defaultValue: FORM_DEFAULT_VALUE_EMPTY,
    render: function render() {
      return /*#__PURE__*/React.createElement("input", {
        hidden: true,
        type: "text"
      });
    }
  });
  // 注册评分
  registerField(FORM_TYPE_RATE, {
    type: FORM_TYPE_RATE,
    defaultValue: FORM_DEFAULT_VALUE_RATE,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly;
      return /*#__PURE__*/React.createElement(Rate, __assign({
        disabled: readonly
      }, field.props));
    }
  });
  // 滑动输入条
  registerField(FORM_TYPE_SLIDER, {
    type: FORM_TYPE_SLIDER,
    defaultValue: FORM_DEFAULT_VALUE_SLIDER,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly;
      return /*#__PURE__*/React.createElement(Slider, __assign({
        disabled: readonly
      }, field.props));
    }
  });
  // 标签选择
  registerField(FORM_TYPE_TAG_GROUP, {
    type: FORM_TYPE_TAG_GROUP,
    defaultValue: FORM_DEFAULT_VALUE_TAG_GROUP,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly;
      return /*#__PURE__*/React.createElement(MwTagGroup, __assign({
        readonly: readonly,
        options: field.options
      }, field.props));
    }
  });
  // 卡片选择
  registerField(FORM_TYPE_CARD_GROUP, {
    type: FORM_TYPE_CARD_GROUP,
    defaultValue: FORM_DEFAULT_VALUE_CARD_GROUP,
    render: function render(_a) {
      var field = _a.field,
        readonly = _a.readonly;
      return /*#__PURE__*/React.createElement(MwCardGroup, __assign({
        readonly: readonly,
        options: field.options
      }, field.props));
    }
  });
  // 注册 html
  registerField(FORM_TYPE_HTML, {
    type: FORM_TYPE_HTML,
    defaultValue: FORM_DEFAULT_VALUE_HTML,
    render: function render(_a) {
      var field = _a.field;
      return /*#__PURE__*/React.createElement("div", {
        dangerouslySetInnerHTML: {
          __html: field.html
        }
      });
    }
  });
};