var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __spreadArray = this && this.__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
import { getKey } from '../../utils';
import { Checkbox } from 'antd';
import React, { useContext, useEffect } from 'react';
import { MwSearchTableContext } from '../../MwSearchTable/context';
import { MwListContext } from '../../MwList/context';
export default function Selection(props) {
  var _a = useContext(MwSearchTableContext),
    selection = _a.selection,
    rowKey = _a.rowKey,
    addSelection = _a.addSelection,
    removeSelection = _a.removeSelection;
  var _b = useContext(MwListContext),
    disabledKeys = _b.disabledKeys,
    setDisabledKeys = _b.setDisabledKeys;
  var record = props.record,
    disabled = props.disabled,
    extendProps = __rest(props, ["record", "disabled"]);
  var isChecked = selection.some(function (row) {
    return getKey(record, rowKey) === getKey(row, rowKey);
  });
  var toggleChecked = function toggleChecked(checked) {
    if (checked) {
      addSelection([record]);
    } else {
      removeSelection(null, record);
    }
  };
  useEffect(function () {
    if (disabled) {
      // 如果禁用了，没有注册过就补一个
      if (!disabledKeys.includes(getKey(record, rowKey))) {
        setDisabledKeys(__spreadArray(__spreadArray([], disabledKeys, true), [getKey(record, rowKey)], false));
      }
    } else {
      // 如果没有禁用，注册过就删掉
      if (disabledKeys.includes(getKey(record, rowKey))) {
        setDisabledKeys(disabledKeys.filter(function (key) {
          return key !== getKey(record, rowKey);
        }));
      }
    }
  }, [disabled, disabledKeys]);
  return /*#__PURE__*/React.createElement(Checkbox, __assign({}, extendProps, {
    disabled: disabled,
    checked: isChecked,
    onChange: function onChange(e) {
      return toggleChecked(e.target.checked);
    }
  }));
}