var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
import { Checkbox } from 'antd';
import React, { useContext } from 'react';
import { MwSearchTableContext } from '../../MwSearchTable/context';
import { MwListContext } from '../../MwList/context';
import { getKey } from '../../utils';
export default function Selection(props) {
  var _a = useContext(MwSearchTableContext),
    selection = _a.selection,
    rowKey = _a.rowKey,
    addSelection = _a.addSelection,
    setSelection = _a.setSelection;
  var _b = useContext(MwListContext),
    data = _b.data,
    disabledKeys = _b.disabledKeys;
  // 获取到已选中的行组成的 keys
  var keys = selection.map(function (row) {
    return getKey(row, rowKey);
  });
  // 获取到没有被禁用的列
  var noDisabledData = data.filter(function (row) {
    return !disabledKeys.includes(getKey(row, rowKey));
  });
  // 是否全选
  var isAllChekced = noDisabledData.every(function (row) {
    return keys.includes(getKey(row, rowKey));
  }) && noDisabledData.length > 0;
  // 是否半选
  var isIndeterminate = noDisabledData.some(function (row) {
    return keys.includes(getKey(row, rowKey));
  }) && !isAllChekced && noDisabledData.length > 0;
  // 切换选中
  var toggleChecked = function toggleChecked() {
    // 去选取消所有选项
    if (isAllChekced) {
      // 当前列表数据组成的 keys
      var dataKeys_1 = data.map(function (row) {
        return getKey(row, rowKey);
      });
      // 过滤掉当前页面所有的 keys 剩下的选项
      var newSelection = selection.filter(function (row) {
        return !dataKeys_1.includes(getKey(row, rowKey));
      });
      // 设置新的选项
      setSelection(newSelection);
    } else {
      // 添加新选项，是个数组
      addSelection(noDisabledData.filter(function (row) {
        return !keys.includes(getKey(row, rowKey));
      }));
    }
  };
  return /*#__PURE__*/React.createElement(Checkbox, __assign({
    indeterminate: isIndeterminate
  }, props, {
    checked: isAllChekced,
    onChange: function onChange(e) {
      return toggleChecked();
    }
  }));
}