var __spreadArray = this && this.__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useEffect, useState } from 'react';
import MwButton from '../../MwButton';
import MwDialog from '../../MwDialog';
import { Dropdown, Menu, Checkbox, Space, Tooltip, Input } from 'antd';
import locale from '../../locale';
import { ReloadOutlined, ColumnHeightOutlined, SettingOutlined, FullscreenOutlined, FullscreenExitOutlined, ArrowUpOutlined, ArrowDownOutlined } from '@ant-design/icons';
/** 表格扩展按钮-是否显示 */
var defaultConfig = {
  /** 扩展栏是否显示 */
  extraVisible: true,
  /** 扩展栏【刷新】按钮是否显示 */
  extraRefreshVisible: true,
  /** 扩展栏【密度】按钮是否显示 */
  extraSizeVisible: true,
  /** 扩展栏【密度】按钮默认值 */
  extraSizeDefaultValue: 'large',
  /** 扩展栏【展示列】按钮是否显示 */
  extraSettingVisible: true,
  /** 扩展栏【全屏】按钮是否显示 */
  extraFullscreenVisible: true
};
export var setSearchTableExtraDefaultValue = function setSearchTableExtraDefaultValue(config) {
  defaultConfig = Object.assign({}, defaultConfig, config);
};
var useFieldsEdit = function useFieldsEdit(tableFields, setTableFields, defaultExtra) {
  var _a = useState(false),
    visible = _a[0],
    setVisible = _a[1];
  var _b = useState(
    // @ts-ignore
    tableFields.filter(function (field) {
      // 已经设置过展示的，直接通过判定
      if (field.__extraTouched) {
        return true;
      }
      return !field.hidden;
    }).map(function (field, i) {
      var _a, _b;
      return {
        checked: defaultExtra.includes((_a = field === null || field === void 0 ? void 0 : field.key) !== null && _a !== void 0 ? _a : '') ? false : field.__hidden === false || field.__hidden === undefined,
        title: field.title || '',
        key: field.key || '',
        order: (_b = field.__order) !== null && _b !== void 0 ? _b : i,
        alias: field.__alias || ''
      };
    })),
    normalFields = _b[0],
    setNormalFields = _b[1];
  useEffect(function () {
    if (defaultExtra && defaultExtra.length) {
      setTimeout(function () {
        handleConfirm();
      }, 800);
    }
    // setTableFields(normalFields)
  }, [defaultExtra]);
  var handleCheckedChange = function handleCheckedChange(i, value) {
    // @ts-ignore
    var newFields = __spreadArray([], normalFields, true);
    var fieldEdit = newFields[i];
    fieldEdit.checked = value;
    setNormalFields(newFields);
  };
  var handleAliasChange = function handleAliasChange(i, value) {
    var newFields = __spreadArray([], normalFields, true);
    var fieldEdit = newFields[i];
    fieldEdit.alias = value || '';
    setNormalFields(newFields);
  };
  /**
   * 向上移动元素位置
   * @param i 当前位置
   */
  var handleMoveUp = function handleMoveUp(i) {
    var _a;
    if (i === 0) {
      return;
    }
    var newFields = __spreadArray([], normalFields, true);
    var current = newFields[i];
    var prev = newFields[i - 1];
    var currentOrder = current.order;
    current.order = prev.order;
    prev.order = currentOrder;
    _a = [newFields[i - 1], newFields[i]], newFields[i] = _a[0], newFields[i - 1] = _a[1];
    setNormalFields(newFields);
  };
  /**
   * 向下移动元素位置
   * @param i 当前位置
   */
  var handleMoveDown = function handleMoveDown(i) {
    var _a;
    if (i === normalFields.length - 1) {
      return;
    }
    var newFields = __spreadArray([], normalFields, true);
    // 赋值 order
    var current = newFields[i];
    var next = newFields[i + 1];
    var currentOrder = current.order;
    current.order = next.order;
    next.order = currentOrder;
    _a = [newFields[i + 1], newFields[i]], newFields[i] = _a[0], newFields[i + 1] = _a[1];
    setNormalFields(newFields);
  };
  /**
   * 确认修改
   */
  var handleConfirm = function handleConfirm() {
    var newFields = __spreadArray([], tableFields, true);
    newFields.filter(function (field) {
      // 已经设置过展示的，直接通过判定
      if (field.__extraTouched) {
        return true;
      }
      return !field.hidden;
    }).forEach(function (field) {
      var target = normalFields.find(function (item) {
        return item.key === field.key;
      });
      if (target) {
        field.__extraTouched = true;
        field.__hidden = !target.checked;
        field.__order = target.order;
        field.__alias = target.alias;
      }
    });
    setTableFields(newFields);
    setVisible(false);
  };
  /**
   *  设置初始选中
   */
  var setDefaultField = function setDefaultField(defaultArray) {
    if (defaultArray === void 0) {
      defaultArray = ['receiptName'];
    }
  };
  return {
    fieldsEdit: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MwDialog, {
      title: locale.extra.columnSetting,
      visible: visible,
      setVisible: setVisible,
      onConfirm: handleConfirm
    }, normalFields.map(function (fieldEdit, i) {
      return !fieldEdit.hidden && /*#__PURE__*/React.createElement("div", {
        className: "mw-search-table-extra-fields-edit-line",
        key: fieldEdit.key
      }, /*#__PURE__*/React.createElement("div", {
        className: "mw-search-table-extra-fields-edit-line-left"
      }, /*#__PURE__*/React.createElement(Checkbox, {
        defaultChecked: fieldEdit.checked,
        onChange: function onChange(e) {
          return handleCheckedChange(i, e.target.checked);
        }
      }, fieldEdit.title)), /*#__PURE__*/React.createElement("div", {
        className: "mw-search-table-extra-fields-edit-line-right"
      }, /*#__PURE__*/React.createElement(Input, {
        style: {
          marginRight: 20
        },
        value: fieldEdit.alias,
        placeholder: locale.extra.rename,
        onChange: function onChange(e) {
          return handleAliasChange(i, e.target.value);
        },
        allowClear: true
      }), /*#__PURE__*/React.createElement(Tooltip, {
        title: locale.extra.moveUp,
        placement: "left"
      }, /*#__PURE__*/React.createElement(MwButton, {
        type: "link",
        icon: /*#__PURE__*/React.createElement(ArrowUpOutlined, null),
        onClick: function onClick() {
          return handleMoveUp(i);
        }
      })), /*#__PURE__*/React.createElement(Tooltip, {
        title: locale.extra.moveDown,
        placement: "right"
      }, /*#__PURE__*/React.createElement(MwButton, {
        type: "link",
        icon: /*#__PURE__*/React.createElement(ArrowDownOutlined, null),
        onClick: function onClick() {
          return handleMoveDown(i);
        }
      }))));
    })), /*#__PURE__*/React.createElement(Tooltip, {
      title: locale.extra.columnSetting
    }, /*#__PURE__*/React.createElement(SettingOutlined, {
      onClick: function onClick() {
        return setVisible(true);
      }
    }))),
    setDefaultField: setDefaultField
  };
};
export default function useExtraBtn(tableRef, searchRef, tableFields, setTableFields, props) {
  // 合并配置
  var config = Object.assign({}, defaultConfig, props);
  var extraVisible = config.extraVisible,
    extraRefreshVisible = config.extraRefreshVisible,
    extraSizeVisible = config.extraSizeVisible,
    extraSizeDefaultValue = config.extraSizeDefaultValue,
    extraSettingVisible = config.extraSettingVisible,
    extraFullscreenVisible = config.extraFullscreenVisible;
  /** 表格尺寸 */
  var _a = useState(extraSizeDefaultValue),
    size = _a[0],
    setSize = _a[1];
  /** 表格全屏 */
  var _b = useState(false),
    isEnter = _b[0],
    setIsEnter = _b[1];
  var _c = useFieldsEdit(tableFields, setTableFields, props.defaultExtra || []),
    fieldsEdit = _c.fieldsEdit,
    setDefaultField = _c.setDefaultField;
  var handleRefresh = function handleRefresh() {
    tableRef.current.refresh();
  };
  var handleSizeChange = function handleSizeChange(e) {
    setSize(e.key);
  };
  useEffect(function () {
    // body 的 style 防止滚动
    if (isEnter) {
      document.body.style.overflow = 'hidden';
    } else {
      document.body.style.overflow = '';
    }
    searchRef.current && searchRef.current.resize();
  }, [isEnter]);
  var extraBtns = extraVisible ? /*#__PURE__*/React.createElement("div", {
    className: "mw-search-table-extra-btns",
    key: "mw-search-table-extra-btns"
  }, /*#__PURE__*/React.createElement(Space, {
    size: "middle"
  }, extraRefreshVisible ? /*#__PURE__*/React.createElement(Tooltip, {
    title: locale.extra.refresh
  }, /*#__PURE__*/React.createElement(ReloadOutlined, {
    onClick: handleRefresh
  })) : null, extraSizeVisible ? /*#__PURE__*/React.createElement(Tooltip, {
    title: locale.extra.density
  }, /*#__PURE__*/React.createElement(Dropdown, {
    overlay: /*#__PURE__*/React.createElement(Menu, {
      style: {
        width: 100
      },
      selectedKeys: [size + ''],
      onClick: handleSizeChange
    }, /*#__PURE__*/React.createElement(Menu.Item, {
      key: "large"
    }, locale.extra.densityLarger), /*#__PURE__*/React.createElement(Menu.Item, {
      key: "middle"
    }, locale.extra.densityMiddle), /*#__PURE__*/React.createElement(Menu.Item, {
      key: "small"
    }, locale.extra.densitySmall))
  }, /*#__PURE__*/React.createElement(ColumnHeightOutlined, null))) : null, extraSettingVisible ? fieldsEdit : null, extraFullscreenVisible ? isEnter ? /*#__PURE__*/React.createElement(Tooltip, {
    title: locale.extra.exitFullScreen,
    key: locale.extra.exitFullScreen
  }, /*#__PURE__*/React.createElement(FullscreenExitOutlined, {
    className: "mw-search-table-fullscrenn-enter",
    onClick: function onClick() {
      return setIsEnter(false);
    }
  })) : /*#__PURE__*/React.createElement(Tooltip, {
    title: locale.extra.fullScreen,
    key: locale.extra.fullScreen
  }, /*#__PURE__*/React.createElement(FullscreenOutlined, {
    className: "mw-search-table-fullscrenn-out",
    onClick: function onClick() {
      return setIsEnter(true);
    }
  })) : null)) : null;
  return {
    extraBtns: extraBtns,
    isEnter: isEnter,
    setIsEnter: setIsEnter,
    size: size,
    setDefaultField: setDefaultField
  };
}