var __spreadArray = this && this.__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
import React from 'react';
import { Tag } from 'antd';
import locale from '../locale';
var CheckableTag = Tag.CheckableTag;
export default function MwTagGroup(props) {
  var value = props.value,
    multiple = props.multiple,
    onChange = props.onChange,
    options = props.options,
    showAllChecked = props.showAllChecked,
    allCheckedText = props.allCheckedText,
    readonly = props.readonly,
    _a = props.cancelable,
    cancelable = _a === void 0 ? true : _a;
  // 如果是多选，且没有默认值，则默认值视为空数组
  if (multiple && value === undefined) {
    value = [];
  }
  // 是否是多选
  var isMultiple = multiple && Array.isArray(value);
  // 是否是空值
  var isEmpty = isMultiple ? value.length === 0 : value === undefined;
  /** 全选 */
  var handleAllSelect = function handleAllSelect() {
    if (readonly) {
      return;
    }
    var newValue;
    if (isMultiple) {
      newValue = [];
    } else {
      if (cancelable) {
        newValue = undefined;
      }
    }
    triggerChange(newValue);
  };
  var triggerChange = function triggerChange(newValue) {
    if (onChange) {
      onChange(newValue);
    }
  };
  /**
   * 切换选中
   * @param checked 是否选中
   * @param option 当前选项
   * @param i 当前选项 id
   */
  var handleTagSelect = function handleTagSelect(checked, option, i) {
    if (readonly) {
      return;
    }
    var newValue;
    if (checked) {
      if (isMultiple) {
        newValue = __spreadArray(__spreadArray([], value, true), [option.value], false);
      } else {
        newValue = option.value;
      }
      triggerChange(newValue);
    } else {
      if (isMultiple) {
        newValue = value.filter(function (v) {
          return v !== option.value;
        });
        triggerChange(newValue);
      } else {
        if (cancelable) {
          newValue = undefined;
          triggerChange(newValue);
        }
      }
    }
  };
  return /*#__PURE__*/React.createElement("div", null, showAllChecked !== false && /*#__PURE__*/React.createElement(CheckableTag, {
    key: "all",
    checked: isEmpty,
    onChange: handleAllSelect
  }, allCheckedText || locale.tagGroup.all), (options || []).map(function (option, i) {
    return /*#__PURE__*/React.createElement(CheckableTag, {
      key: option.value,
      checked: isMultiple ? value.includes(option.value) : value === option.value,
      onChange: function onChange(checked) {
        return handleTagSelect(checked, option, i);
      }
    }, option.label);
  }));
}