"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addRefresh = void 0;
exports.default = MwButton;
exports.setPermissionList = exports.removeRefresh = exports.hasPermission = void 0;
var _react = _interopRequireWildcard(require("react"));
var _antd = require("antd");
var _classnames = _interopRequireDefault(require("classnames"));
var _utils = require("../utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var refreshList = [];
var addRefresh = function addRefresh(setRefresh) {
  refreshList.push(setRefresh);
};
exports.addRefresh = addRefresh;
var removeRefresh = function removeRefresh(setRefresh) {
  var refreshIndex = refreshList.findIndex(function (item) {
    return item === setRefresh;
  });
  if (refreshIndex >= 0) {
    refreshList.splice(refreshIndex, 1);
  }
};
// 权限列表
exports.removeRefresh = removeRefresh;
var permissionList = [];
var setPermissionList = function setPermissionList(list) {
  permissionList = list;
  refreshList.forEach(function (setRefresh) {
    setRefresh(Math.random());
  });
};
exports.setPermissionList = setPermissionList;
var hasPermission = function hasPermission(permission) {
  if (!permission) {
    return true;
  }
  if (permissionList.includes(permission)) {
    return true;
  }
  return false;
};
exports.hasPermission = hasPermission;
var keys = ['confirm', 'onConfirm', 'confirmMsg', 'tableFooterExtraOnly', 'action', 'api', 'onFinish', '__simple', 'deleteApi', 'detailApi', 'detailParams', 'detailApiFilter', 'permission', 'extra', 'record', 'confirmVisible', 'sub', 'omitKeys'];
function MwButton(props) {
  var _a = (0, _react.useState)(0),
    setRefresh = _a[1];
  var params = __assign({}, props);
  (0, _react.useEffect)(function () {
    addRefresh(setRefresh);
    return function () {
      removeRefresh(setRefresh);
    };
  }, []);
  // 权限控制
  if (params.permission && !permissionList.includes(params.permission)) {
    return null;
  }
  // 控制样式
  var className = ["mw-button"];
  // 是否在折叠按钮里面
  if (props.__simple) {
    className.push('simple');
  }
  // 是否是次级按钮
  if (props.sub) {
    className.push('sub');
  }
  // 是否有自定义样式
  if (props.className) {
    className.push(props.className);
  }
  className = (0, _classnames.default)(className);
  // 删除一些没有用到的属性
  if (props.omitKeys) {
    params = (0, _utils.omitObj)(params, props.omitKeys);
  }
  params = (0, _utils.omitObj)(params, keys);
  // 基础按钮
  var btn = /*#__PURE__*/_react.default.createElement(_antd.Button, __assign({
    className: className
  }, params), props.children);
  // 带悬浮提示
  if (props.tooltip) {
    btn = /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
      title: props.tooltip
    }, btn);
  }
  // 带确认提示
  if (props.confirm && !props.disabled) {
    if (!props.__simple) {
      return /*#__PURE__*/_react.default.createElement(_antd.Popconfirm, {
        title: props.confirmMsg,
        onConfirm: function onConfirm() {
          return props.onConfirm && props.onConfirm();
        }
      }, btn);
    } else {
      return /*#__PURE__*/_react.default.createElement(_antd.Button, __assign({
        className: className
      }, params, {
        onClick: function onClick() {
          _antd.Modal.confirm({
            content: props.confirmMsg,
            onOk: function onOk() {
              return props.onConfirm && props.onConfirm();
            }
          });
        }
      }), props.children);
    }
  }
  return btn;
}
MwButton.componentName = 'MwButton';