"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = MwCtrl;
var _react = _interopRequireWildcard(require("react"));
var _antd = require("antd");
var _MwButton = _interopRequireWildcard(require("../MwButton"));
var _MwAction = _interopRequireDefault(require("../MwAction"));
var _constant = require("../constant");
var _icons = require("@ant-design/icons");
var _classnames = _interopRequireDefault(require("classnames"));
var _locale = _interopRequireDefault(require("../locale"));
require("./mw-ctrl.css");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
/**
 * 返回一个控制项
 * @param node 节点
 * @param key key
 */
var getCtrlItem = function getCtrlItem(node, key, defaultProps) {
  var _a, _b;
  var props = __assign({}, node.props);
  if (((_a = node === null || node === void 0 ? void 0 : node.type) === null || _a === void 0 ? void 0 : _a.componentName) === 'MwAction' || ((_b = node === null || node === void 0 ? void 0 : node.type) === null || _b === void 0 ? void 0 : _b.componentName) === 'MwButton') {
    return /*#__PURE__*/_react.default.createElement(_MwAction.default, __assign({
      key: key,
      type: "link"
    }, defaultProps, props));
  }
  return node;
};
/**
 * 将子节点转化成 MwAction 按钮
 * @param children 子节点
 */
var getCtrlList = function getCtrlList(children, props) {
  var _a = props.max,
    max = _a === void 0 ? _constant.CTRL_DEFAULT_MAX : _a,
    sub = props.sub,
    _b = props.more,
    more = _b === void 0 ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _locale.default.table.actionRowMore || _constant.CTRL_DEFAULT_MORE_TEXT, " ", /*#__PURE__*/_react.default.createElement(_icons.DownOutlined, null)) : _b;
  var ctrlList = [];
  if (!children.length || children.length === 1 && !children[0]) {
    return [];
  }
  // 如果节点只有一个元素
  if (children.length === 1) {
    return [getCtrlItem(children[0], 'key', {
      sub: sub
    })];
  }
  // 过滤掉无权限按钮和 null
  children = children.filter(function (node) {
    var _a;
    return node !== null && (0, _MwButton.hasPermission)((_a = node === null || node === void 0 ? void 0 : node.props) === null || _a === void 0 ? void 0 : _a.permission);
  });
  // 渲染没有折叠前的按钮
  for (var i = 0; i < (children.length <= max + 1 ? children.length : max); i++) {
    var node = children[i];
    if (!node) {
      continue;
    }
    var CtrlItem
    // 正常节点
    = void 0;
    // 正常节点
    CtrlItem = getCtrlItem(node, i, {
      sub: sub
    });
    // 添加这个节点
    ctrlList.push(CtrlItem);
  }
  // 多余的按钮会变成下拉菜单
  if (children.length > max + 1) {
    var menuList = [];
    for (var i = max; i < children.length; i++) {
      var node = children[i];
      if (!node) {
        continue;
      }
      var CtrlItem
      // 正常节点
      = void 0;
      // 正常节点
      CtrlItem = getCtrlItem(node, i, {
        __simple: true,
        type: 'text'
      });
      // 添加这个节点
      menuList.push( /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
        style: {
          padding: 0
        },
        key: max + i
      }, CtrlItem));
    }
    var menu = /*#__PURE__*/_react.default.createElement(_antd.Menu, {
      style: {
        minWidth: 100
      }
    }, menuList);
    ctrlList.push( /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
      key: max,
      overlay: menu,
      placement: "bottomRight"
    }, /*#__PURE__*/_react.default.createElement(_MwButton.default, {
      type: "link",
      className: (0, _classnames.default)('mw-button', sub && 'sub')
    }, more)));
  }
  return ctrlList;
};
function MwCtrl(props) {
  var _a = (0, _react.useState)(0),
    setRefresh = _a[1];
  var children = props.children,
    split = props.split,
    size = props.size,
    sub = props.sub,
    className = props.className,
    style = props.style;
  if (!Array.isArray(children)) {
    children = [children];
  }
  var ctrlList = getCtrlList(children, props);
  (0, _react.useEffect)(function () {
    (0, _MwButton.addRefresh)(setRefresh);
  }, []);
  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    size: size,
    className: (0, _classnames.default)('mw-ctrl', className),
    style: style,
    split: split !== null && split !== void 0 ? split : /*#__PURE__*/_react.default.createElement(_antd.Divider, {
      type: "vertical"
    })
  }, ctrlList);
}