"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AyDialogFooter = AyDialogFooter;
exports.default = MwDialog;
exports.setGlobalDialogField = exports.defaultProps = void 0;
var _react = _interopRequireDefault(require("react"));
var _MwButton = _interopRequireDefault(require("../MwButton"));
var _antd = require("antd");
var _locale = _interopRequireDefault(require("../locale"));
var _utils = require("../utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var usedKeys = ['loading', 'confirmVisible', 'cancelVisible', 'confirmText', 'cancelText', 'confirmProps', 'cancelProps', 'confirmBefore', 'confirmAfter', 'cancelBefore', 'cancelAfter'];
function AyDialogFooter(props, handleCancel, handleConfirm) {
  var loading = props.loading,
    confirmVisible = props.confirmVisible,
    cancelVisible = props.cancelVisible,
    confirmText = props.confirmText,
    cancelText = props.cancelText,
    confirmProps = props.confirmProps,
    cancelProps = props.cancelProps,
    confirmBefore = props.confirmBefore,
    confirmAfter = props.confirmAfter,
    cancelBefore = props.cancelBefore,
    cancelAfter = props.cancelAfter;
  return /*#__PURE__*/_react.default.createElement(_antd.Space, null, cancelBefore, cancelVisible !== false && /*#__PURE__*/_react.default.createElement(_MwButton.default, __assign({}, cancelProps, {
    onClick: handleCancel
  }), cancelText || _locale.default.dialog.close), cancelAfter, confirmBefore, confirmVisible !== false && /*#__PURE__*/_react.default.createElement(_MwButton.default, __assign({
    type: "primary"
  }, confirmProps, {
    onClick: handleConfirm,
    loading: loading
  }), confirmText || _locale.default.dialog.confirm), confirmAfter);
}
var defaultProps = {};
exports.defaultProps = defaultProps;
var setGlobalDialogField = function setGlobalDialogField(cb) {
  exports.defaultProps = defaultProps = __assign(__assign({}, cb()), defaultProps);
};
exports.setGlobalDialogField = setGlobalDialogField;
function MwDialog(props) {
  var title = props.title,
    titleBefore = props.titleBefore,
    titleAfter = props.titleAfter,
    children = props.children,
    visible = props.visible,
    setVisible = props.setVisible,
    onConfirm = props.onConfirm,
    onOk = props.onOk,
    onClose = props.onClose,
    onCancel = props.onCancel,
    footer = props.footer,
    width = props.width,
    drawer = props.drawer,
    extraProps = __rest(props, ["title", "titleBefore", "titleAfter", "children", "visible", "setVisible", "onConfirm", "onOk", "onClose", "onCancel", "footer", "width", "drawer"]);
  var extraPropsExtend = __assign(__assign({}, defaultProps), extraProps);
  var handleCancel = function handleCancel() {
    setVisible && setVisible(false);
    onClose && onClose();
    onCancel && onCancel();
  };
  var handleConfirm = function handleConfirm() {
    if (onConfirm) {
      onConfirm();
    }
    if (onOk) {
      onOk();
    }
  };
  // 弹窗底部按钮
  var getDialogFooter = function getDialogFooter() {
    if (footer === false || footer === null) {
      return null;
    } else if (footer === undefined) {
      return AyDialogFooter(props, handleCancel, handleConfirm);
    }
    return footer;
  };
  var dialogProps = drawer ? __assign({
    width: width || 500,
    title: /*#__PURE__*/_react.default.createElement(_antd.Space, null, titleBefore, title, titleAfter),
    visible: visible,
    closable: true,
    onClose: handleCancel,
    footer: getDialogFooter()
  }, (0, _utils.omitObj)(extraPropsExtend, usedKeys)) : __assign({
    width: width || 500,
    title: /*#__PURE__*/_react.default.createElement(_antd.Space, null, titleBefore, title, titleAfter),
    visible: visible,
    onCancel: handleCancel,
    footer: getDialogFooter()
  }, (0, _utils.omitObj)(extraPropsExtend, usedKeys));
  return drawer ? /*#__PURE__*/_react.default.createElement(_antd.Drawer, __assign({
    footerStyle: {
      textAlign: 'right'
    }
  }, dialogProps), children) : /*#__PURE__*/_react.default.createElement(_antd.Modal, __assign({}, dialogProps), children);
}