"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.MODE_VIEW = exports.MODE_UPDATE = exports.MODE_CUSTOM = exports.MODE_ADD = void 0;
var _react = _interopRequireWildcard(require("react"));
var _antd = require("antd");
var _MwDialog = _interopRequireDefault(require("../MwDialog"));
var _MwForm = _interopRequireDefault(require("../MwForm"));
var _convertFields = require("../MwFields/convertFields");
var _utils = require("../utils");
var _locale = _interopRequireDefault(require("../locale"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
/** 新增模式 */
var MODE_ADD = 'add';
/** 修改模式 */
exports.MODE_ADD = MODE_ADD;
var MODE_UPDATE = 'update';
/** 详情模式 */
exports.MODE_UPDATE = MODE_UPDATE;
var MODE_VIEW = 'view';
/** 自定义模式 */
exports.MODE_VIEW = MODE_VIEW;
var MODE_CUSTOM = 'custom';
/**
 * 过滤获得 form 的配置项
 * @param fields 配置项 (dialog-form)
 */
exports.MODE_CUSTOM = MODE_CUSTOM;
var getAyFormFields = function getAyFormFields(fields, mode, initParams, dialogOnly) {
  return fields.filter(function (field) {
    if (dialogOnly) {
      return !!field.dialog;
    } else {
      return true;
    }
  }).map(function (field) {
    var dialog = field.dialog;
    var formField = __assign(__assign(__assign({
      key: '_'
    }, (0, _utils.omitObj)(field, ['dialog'])), dialog), {
      _values: initParams
    });
    if (typeof formField.reSetting === 'function') {
      formField = formField.reSetting(formField, mode);
    }
    return formField;
  }).filter(function (field) {
    if (field && Array.isArray(field.hiddenMode) && mode) {
      return !field.hiddenMode.includes(mode);
    }
    return field;
  });
};
var getTitle = function getTitle(mode, title) {
  var _a;
  if (title) {
    return title;
  }
  var map = (_a = {}, _a[MODE_ADD] = _locale.default.dialog.modeAdd, _a[MODE_UPDATE] = _locale.default.dialog.modeUpdate, _a[MODE_VIEW] = _locale.default.dialog.modeDetail, _a[MODE_CUSTOM] = _locale.default.dialog.modeCustom, _a);
  return map[mode];
};
var dialogResolve;
var dialogReject;
/**
 * antd form 原生支持的方法尽数暴露出去
 */
var funcs = ['getFieldValue', 'getFieldsValue', 'getFieldError', 'getFieldsError', 'isFieldTouched', 'isFieldsTouched', 'isFieldValidating', 'resetFields', 'scrollToField', 'setFields', 'setFieldsValue', 'submit', 'validateFields'];
var _default = /*#__PURE__*/(0, _react.forwardRef)(function MwDialogForm(props, ref) {
  var originFields = props.fields,
    title = props.title,
    addApi = props.addApi,
    updateApi = props.updateApi,
    span = props.span,
    width = props.width,
    name = props.name,
    beforeSubmit = props.beforeSubmit,
    dialogExtend = props.dialogExtend,
    formExtend = props.formExtend,
    drawer = props.drawer,
    dialogOnly = props.dialogOnly,
    _a = props.autoClose,
    autoClose = _a === void 0 ? true : _a,
    defaultVisible = props.visible,
    defaultMode = props.mode,
    _b = props.spinning,
    spinning = _b === void 0 ? false : _b,
    onClose = props.onClose,
    onCancel = props.onCancel,
    onSuccess = props.onSuccess,
    onError = props.onError,
    initialValues = props.initialValues,
    children = props.children;
  var fields = (0, _react.useMemo)(function () {
    var childrenFields = (0, _convertFields.convertChildrenToField)(children);
    return __spreadArray(__spreadArray([], originFields || [], true), childrenFields, true);
  }, [originFields, children]);
  /** 弹窗是否可见 */
  var _c = (0, _react.useState)(false),
    visible = _c[0],
    setVisible = _c[1];
  /** 当前所处于的模式 */
  var _d = (0, _react.useState)(MODE_ADD),
    mode = _d[0],
    setMode = _d[1];
  /** 表单是否可以编辑 */
  var _e = (0, _react.useState)(false),
    readonly = _e[0],
    setReadonly = _e[1];
  /** 是否正在保存中 */
  var _f = (0, _react.useState)(false),
    loading = _f[0],
    setLoading = _f[1];
  /** 默认参数 */
  var _g = (0, _react.useState)({}),
    initParams = _g[0],
    setInitParams = _g[1];
  /** form 需要的 fields */
  var _h = (0, _react.useState)(getAyFormFields(fields, mode, initParams, dialogOnly)),
    formFields = _h[0],
    setFormFields = _h[1];
  /** form 控制 (需要主动调用里面的事件) */
  var formRef = (0, _react.useRef)();
  /** 默认弹窗标题 */
  var _j = (0, _react.useState)(title),
    dialogTitle = _j[0],
    setDialogTitle = _j[1];
  /** 打开弹窗的配置 */
  var _k = (0, _react.useState)({}),
    config = _k[0],
    setConfig = _k[1];
  var debounce = function debounce(func, delay) {
    var timeout;
    return function () {
      var _this = this;
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      clearTimeout(timeout);
      timeout = setTimeout(function () {
        func.apply(_this, args);
      }, delay);
    };
  };
  (0, _react.useEffect)(function () {
    setFormFields(getAyFormFields(fields, mode, initParams, dialogOnly));
  }, [fields]);
  (0, _react.useEffect)(function () {
    setDialogTitle(title);
  }, [title]);
  // 监听显示变化
  (0, _react.useEffect)(function () {
    setVisible(!!defaultVisible);
    if (defaultVisible) {
      requestAnimationFrame(function () {
        var _a;
        (_a = formRef.current) === null || _a === void 0 ? void 0 : _a.resetFields();
      });
      if (initialValues) {
        requestAnimationFrame(function () {
          var _a;
          (_a = formRef.current) === null || _a === void 0 ? void 0 : _a.setFieldsValue(initialValues);
        });
      }
    }
  }, [defaultVisible, initialValues]);
  (0, _react.useEffect)(function () {
    if (defaultMode) {
      setReadonly(defaultMode === MODE_VIEW);
      setMode(defaultMode);
    }
  }, [defaultMode]);
  /**
   * 初始化弹窗
   * @step 1、打开弹窗，清空只读
   * @step 2、如果有值，清空表单值
   * @step 3、如果有默认参数、设置默认参数
   * @param params 默认值
   * @param config 标题、fields 配置
   */
  var initDialog = function initDialog(params, config) {
    setReadonly(false);
    setConfig(config || {});
    if (config && config.fields) {
      formFields = getAyFormFields(config.fields, mode, initParams, dialogOnly);
      setFormFields(formFields);
      // 同步刷新 renderContent、render 函数
      (0, _react.useEffect)(function () {
        setFormFields(getAyFormFields(config.fields, mode, initParams, dialogOnly));
      }, [config.fields]);
    } else {
      formFields = getAyFormFields(fields, mode, initParams, dialogOnly);
      setFormFields(formFields);
    }
    // 设置标题
    if (config && config.title) {
      setDialogTitle(config.title);
    }
    // 打开弹窗
    setVisible(true);
    // 第二次之后清空数据
    if (formRef.current) {
      formRef.current.resetFields();
    }
    // 设置默认值
    if (params) {
      setInitParams(params);
      requestAnimationFrame(function () {
        formRef.current.setFieldsValue(params);
      });
    } else {
      setInitParams({});
    }
  };
  var formInstans = {
    /**
     * 新增表单
     * @param params 默认值
     */
    add: function add(params, config) {
      return new Promise(function (resolve, reject) {
        dialogResolve = resolve;
        dialogReject = reject;
        mode = MODE_ADD;
        setMode(defaultMode || MODE_ADD);
        initDialog(params, config);
      });
    },
    /**
     * 修改表单
     * @param params 默认值
     */
    update: function update(params, config) {
      return new Promise(function (resolve, reject) {
        dialogResolve = resolve;
        dialogReject = reject;
        mode = MODE_UPDATE;
        setMode(defaultMode || MODE_UPDATE);
        initDialog(params, config);
      });
    },
    /**
     * 查看表单
     * @param params 默认值
     * @param config
     */
    view: function view(params, config) {
      mode = MODE_VIEW;
      setMode(defaultMode || MODE_VIEW);
      initDialog(params, config);
      setTimeout(function () {
        setReadonly(true);
      });
    },
    /**
     * 自定义表单，打开表单
     * @param params 默认值
     */
    open: function open(params, config) {
      mode = MODE_CUSTOM;
      setMode(defaultMode || MODE_CUSTOM);
      initDialog(params, config);
    },
    /**
     * 刷新
     */
    refreshFields: function refreshFields() {
      setFormFields(getAyFormFields(fields, mode, initParams, dialogOnly));
    },
    /**
     * 获取 form ref
     */
    getFormRef: function getFormRef() {
      return formRef;
    },
    /**
     * 关闭弹窗
     */
    closeDialog: function closeDialog() {
      _closeDialog();
    }
  };
  // 支持所有表单的方法
  funcs.forEach(function (func) {
    formInstans[func] = function () {
      var _a;
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      return (_a = formRef.current)[func].apply(_a, args);
    };
  });
  // @ts-ignore 控制暴露出去的方法
  (0, _react.useImperativeHandle)(ref, function () {
    return formInstans;
  });
  /**
   * 弹窗确定触发表单提交
   */
  var onConfirm = function onConfirm() {
    formRef.current.submit();
  };
  /**
   * 关闭弹窗
   */
  var _closeDialog = function _closeDialog() {
    setVisible(false);
    onClose && onClose();
    onCancel && onCancel();
  };
  /**
   * 表单提交
   * @step 1、根据不同模式获取不同的 API 接口
   * @step 2、开始 loading
   * @step 3、成功后 reolsve、关闭弹窗
   * @step 4、关闭 loading
   * @param values 提交参数
   */
  var handleSubmit = function handleSubmit(values) {
    var _a;
    if (loading) {
      return;
    }
    var apiMap = (_a = {}, _a[MODE_ADD] = addApi, _a[MODE_UPDATE] = updateApi, _a[MODE_CUSTOM] = config.api, _a);
    var api = apiMap[mode];
    if (api) {
      var params_1 = __assign(__assign({}, initParams), values);
      // 删除初始化的值携带
      for (var key in initParams) {
        if (key.startsWith('__')) {
          delete params_1[key];
        }
      }
      if (typeof beforeSubmit === 'function') {
        var result = beforeSubmit(params_1, mode);
        if (result !== false) {
          params_1 = result;
        } else {
          return;
        }
      }
      // 这个是兼容弹窗里面有编辑表格的时候，setLoading好像会触发重新渲染
      // 所以先这样处理
      !(props === null || props === void 0 ? void 0 : props.stopLoading) && setLoading(true);
      api(params_1).then(function (data) {
        if (dialogResolve) {
          dialogResolve({
            data: data,
            values: values,
            params: params_1,
            initParams: initParams,
            closeDialog: _closeDialog
          });
        }
        if (config.onSuccess) {
          config.onSuccess({
            data: data,
            values: values,
            params: params_1,
            initParams: initParams,
            closeDialog: _closeDialog
          });
        }
        if (onSuccess) {
          onSuccess({
            data: data,
            values: values,
            params: params_1,
            initParams: initParams,
            closeDialog: _closeDialog
          });
        }
        if (autoClose) {
          _closeDialog();
        }
      }, function (error) {
        if (dialogReject) {
          dialogReject({
            error: error,
            values: values,
            params: params_1,
            initParams: initParams,
            closeDialog: _closeDialog
          });
        }
        if (config.onError) {
          config.onError({
            error: error,
            values: values,
            params: params_1,
            initParams: initParams,
            closeDialog: _closeDialog
          });
        }
        if (onError) {
          onError({
            error: error,
            values: values,
            params: params_1,
            initParams: initParams,
            closeDialog: _closeDialog
          });
        }
      }).finally(function () {
        setLoading(false);
      });
    }
  };
  return /*#__PURE__*/_react.default.createElement(_MwDialog.default, __assign({
    width: width,
    title: getTitle(mode, dialogTitle),
    visible: visible,
    drawer: drawer,
    onConfirm: debounce(function () {
      !loading && onConfirm();
    }, 300),
    loading: loading,
    forceRender: true,
    onClose: _closeDialog,
    confirmLoading: loading,
    confirmVisible: mode !== MODE_VIEW && config.readonly !== true
  }, dialogExtend, config === null || config === void 0 ? void 0 : config.dialogExtend), /*#__PURE__*/_react.default.createElement(_antd.Spin, {
    spinning: spinning
  }, /*#__PURE__*/_react.default.createElement(_MwForm.default, __assign({
    name: name,
    readonly: readonly,
    ref: formRef,
    fields: formFields,
    span: span || 22,
    onConfirm: handleSubmit
  }, formExtend))));
});
exports.default = _default;