"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.convertChildrenToField = void 0;
var _utils = require("../utils");
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
var getAyFieldsNode = function getAyFieldsNode(children) {
  if (!Array.isArray(children)) {
    children = [children];
  }
  // @ts-ignore
  return children.find(function (node) {
    var _a;
    return ((_a = node === null || node === void 0 ? void 0 : node.type) === null || _a === void 0 ? void 0 : _a.componentName) === 'MwFields';
  });
};
var convertChildrenToField = function convertChildrenToField(children) {
  // 获得子元素名为 MwFields 的节点
  var ayFields = getAyFieldsNode(children);
  if (!ayFields) {
    return [];
  }
  // 获得到子元素
  var ayFieldsChildren = ayFields === null || ayFields === void 0 ? void 0 : ayFields.props.children;
  return loop(ayFieldsChildren);
};
exports.convertChildrenToField = convertChildrenToField;
function loop(children) {
  if (!Array.isArray(children)) {
    children = [children];
  }
  var newChildren = [];
  // @ts-ignore
  children.forEach(function (node) {
    var _a, _b;
    if (node) {
      if (((_a = node === null || node === void 0 ? void 0 : node.type) === null || _a === void 0 ? void 0 : _a.toString()) === 'Symbol(react.fragment)' && ((_b = node === null || node === void 0 ? void 0 : node.props) === null || _b === void 0 ? void 0 : _b.children)) {
        newChildren.push.apply(newChildren, loop(node.props.children));
        return;
      }
      var newNode = __assign(__assign({}, node === null || node === void 0 ? void 0 : node.props), {
        key: node.key
      });
      if (Array.isArray(newNode === null || newNode === void 0 ? void 0 : newNode.children) || (0, _utils.isObj)(newNode === null || newNode === void 0 ? void 0 : newNode.children)) {
        if ((0, _utils.isObj)(newNode === null || newNode === void 0 ? void 0 : newNode.children)) {
          newNode.children = loop([newNode.children]);
        } else {
          newNode.children = loop(__spreadArray([], newNode.children, true));
        }
      }
      newChildren.push(newNode);
    }
  });
  return newChildren;
}