"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = MwFormList;
var _react = _interopRequireWildcard(require("react"));
var _antd = require("antd");
var _locale = _interopRequireDefault(require("../locale"));
var _icons = require("@ant-design/icons");
var _constant = require("../constant");
var _parseFields = require("./parseFields");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
function MwFormList(props) {
  var field = props.field,
    getFormItem = props.getFormItem,
    formInstant = props.formInstant,
    ayFormProps = props.ayFormProps;
  var readonly = ayFormProps.readonly;
  // 最少行 & 最大行
  var _a = field.min,
    min = _a === void 0 ? 0 : _a,
    _b = field.max,
    max = _b === void 0 ? Infinity : _b;
  // 当前行数
  var _c = (0, _react.useState)(0),
    recordNum = _c[0],
    setRecordNum = _c[1];
  (0, _react.useEffect)(function () {
    setRecordNum(formInstant.getFieldValue(field.key).length);
  }, []);
  /**
   * 复制这行数据到末尾
   * @param name 实际上是当前行 index
   */
  var handleCopy = function handleCopy(name) {
    var _a;
    try {
      var value = formInstant.getFieldValue(field.key);
      var newValue = __spreadArray(__spreadArray([], value, true), [value[name]], false);
      setRecordNum(newValue.length);
      formInstant.setFieldsValue((_a = {}, _a[field.key || ''] = newValue, _a));
    } catch (_b) {
      console.error('复制失败');
    }
  };
  /**
   * 删除这行数据
   * @param name 实际上是当前行 index
   * @param remove 删除方法
   */
  var handleRemove = function handleRemove(name, remove) {
    remove(name);
    setRecordNum(Number(recordNum) - 1);
  };
  /**
   * 新增一行
   * @param add 新增方法
   */
  var handleAdd = function handleAdd(add) {
    add(field.creatorRecord || {});
    setRecordNum(Number(recordNum) + 1);
  };
  return /*#__PURE__*/_react.default.createElement(_antd.Form.List, __assign({}, field.props, {
    name: field.key || field.label,
    key: field.key || field.label
  }), function (fields, _a) {
    var add = _a.add,
      remove = _a.remove;
    var value = readonly ? formInstant.getFieldValue(field.key) : [];
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, fields.map(function (_a) {
      var key = _a.key,
        name = _a.name,
        restField = __rest(_a, ["key", "name"]);
      var children = field.children || [];
      if (!Array.isArray(children)) {
        children = [children];
      }
      var content = getFormItem(children.map(function (child) {
        var newField = __assign(__assign({}, child), {
          formItemProps: __assign(__assign(__assign({}, field.formItemProps), restField), {
            name: [name, child.key]
          })
        });
        if (readonly && !newField.render) {
          try {
            var text = value[name][child.key];
            // 日期或者日期区间
            if (newField.type === _constant.FORM_TYPE_DATE || Array.isArray(text) && newField.type === _constant.FORM_TYPE_DATE_RANGE) {
              text = (0, _parseFields.getDateValue)(text, newField, readonly);
            }
            newField.text = text;
          } catch (_a) {
            console.error('mw-form-list 转换错误');
          }
        }
        return newField;
      }), formInstant, ayFormProps, _constant.FORM_TYPE_LIST);
      return /*#__PURE__*/_react.default.createElement(_antd.Space, __assign({
        key: "".concat(field.key, "-").concat(key),
        className: "mw-form-list-item",
        align: "end"
      }, field.spaceProps), content, !readonly && /*#__PURE__*/_react.default.createElement(_antd.Space, {
        className: "mw-form-list-actions"
      }, recordNum < max && /*#__PURE__*/_react.default.createElement("span", {
        className: "mw-form-list-action",
        onClick: function onClick() {
          return handleCopy(name);
        }
      }, /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
        title: _locale.default.form.copyToEnd
      }, /*#__PURE__*/_react.default.createElement(_icons.CopyOutlined, null))), recordNum > min && /*#__PURE__*/_react.default.createElement("span", {
        className: "mw-form-list-action",
        onClick: function onClick() {
          return handleRemove(name, remove);
        }
      }, /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
        title: _locale.default.form.removeRow
      }, /*#__PURE__*/_react.default.createElement(_icons.DeleteOutlined, null)))));
    }), recordNum < max && !readonly && /*#__PURE__*/_react.default.createElement(_antd.Button, {
      type: "dashed",
      onClick: function onClick() {
        return handleAdd(add);
      },
      icon: /*#__PURE__*/_react.default.createElement(_icons.PlusOutlined, null)
    }, _locale.default.form.addItem));
  });
}