"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Selection;
var _utils = require("../../utils");
var _antd = require("antd");
var _react = _interopRequireWildcard(require("react"));
var _context = require("../../MwSearchTable/context");
var _context2 = require("../../MwList/context");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
function Selection(props) {
  var _a = (0, _react.useContext)(_context.MwSearchTableContext),
    selection = _a.selection,
    rowKey = _a.rowKey,
    addSelection = _a.addSelection,
    removeSelection = _a.removeSelection;
  var _b = (0, _react.useContext)(_context2.MwListContext),
    disabledKeys = _b.disabledKeys,
    setDisabledKeys = _b.setDisabledKeys;
  var record = props.record,
    disabled = props.disabled,
    extendProps = __rest(props, ["record", "disabled"]);
  var isChecked = selection.some(function (row) {
    return (0, _utils.getKey)(record, rowKey) === (0, _utils.getKey)(row, rowKey);
  });
  var toggleChecked = function toggleChecked(checked) {
    if (checked) {
      addSelection([record]);
    } else {
      removeSelection(null, record);
    }
  };
  (0, _react.useEffect)(function () {
    if (disabled) {
      // 如果禁用了，没有注册过就补一个
      if (!disabledKeys.includes((0, _utils.getKey)(record, rowKey))) {
        setDisabledKeys(__spreadArray(__spreadArray([], disabledKeys, true), [(0, _utils.getKey)(record, rowKey)], false));
      }
    } else {
      // 如果没有禁用，注册过就删掉
      if (disabledKeys.includes((0, _utils.getKey)(record, rowKey))) {
        setDisabledKeys(disabledKeys.filter(function (key) {
          return key !== (0, _utils.getKey)(record, rowKey);
        }));
      }
    }
  }, [disabled, disabledKeys]);
  return /*#__PURE__*/_react.default.createElement(_antd.Checkbox, __assign({}, extendProps, {
    disabled: disabled,
    checked: isChecked,
    onChange: function onChange(e) {
      return toggleChecked(e.target.checked);
    }
  }));
}