"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Selection;
var _antd = require("antd");
var _react = _interopRequireWildcard(require("react"));
var _context = require("../../MwSearchTable/context");
var _context2 = require("../../MwList/context");
var _utils = require("../../utils");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function Selection(props) {
  var _a = (0, _react.useContext)(_context.MwSearchTableContext),
    selection = _a.selection,
    rowKey = _a.rowKey,
    addSelection = _a.addSelection,
    setSelection = _a.setSelection;
  var _b = (0, _react.useContext)(_context2.MwListContext),
    data = _b.data,
    disabledKeys = _b.disabledKeys;
  // 获取到已选中的行组成的 keys
  var keys = selection.map(function (row) {
    return (0, _utils.getKey)(row, rowKey);
  });
  // 获取到没有被禁用的列
  var noDisabledData = data.filter(function (row) {
    return !disabledKeys.includes((0, _utils.getKey)(row, rowKey));
  });
  // 是否全选
  var isAllChekced = noDisabledData.every(function (row) {
    return keys.includes((0, _utils.getKey)(row, rowKey));
  }) && noDisabledData.length > 0;
  // 是否半选
  var isIndeterminate = noDisabledData.some(function (row) {
    return keys.includes((0, _utils.getKey)(row, rowKey));
  }) && !isAllChekced && noDisabledData.length > 0;
  // 切换选中
  var toggleChecked = function toggleChecked() {
    // 去选取消所有选项
    if (isAllChekced) {
      // 当前列表数据组成的 keys
      var dataKeys_1 = data.map(function (row) {
        return (0, _utils.getKey)(row, rowKey);
      });
      // 过滤掉当前页面所有的 keys 剩下的选项
      var newSelection = selection.filter(function (row) {
        return !dataKeys_1.includes((0, _utils.getKey)(row, rowKey));
      });
      // 设置新的选项
      setSelection(newSelection);
    } else {
      // 添加新选项，是个数组
      addSelection(noDisabledData.filter(function (row) {
        return !keys.includes((0, _utils.getKey)(row, rowKey));
      }));
    }
  };
  return /*#__PURE__*/_react.default.createElement(_antd.Checkbox, __assign({
    indeterminate: isIndeterminate
  }, props, {
    checked: isAllChekced,
    onChange: function onChange(e) {
      return toggleChecked();
    }
  }));
}