"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useExtraBtn;
exports.setSearchTableExtraDefaultValue = void 0;
var _react = _interopRequireWildcard(require("react"));
var _MwButton = _interopRequireDefault(require("../../MwButton"));
var _MwDialog = _interopRequireDefault(require("../../MwDialog"));
var _antd = require("antd");
var _locale = _interopRequireDefault(require("../../locale"));
var _icons = require("@ant-design/icons");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
/** 表格扩展按钮-是否显示 */
var defaultConfig = {
  /** 扩展栏是否显示 */
  extraVisible: true,
  /** 扩展栏【刷新】按钮是否显示 */
  extraRefreshVisible: true,
  /** 扩展栏【密度】按钮是否显示 */
  extraSizeVisible: true,
  /** 扩展栏【密度】按钮默认值 */
  extraSizeDefaultValue: 'large',
  /** 扩展栏【展示列】按钮是否显示 */
  extraSettingVisible: true,
  /** 扩展栏【全屏】按钮是否显示 */
  extraFullscreenVisible: true
};
var setSearchTableExtraDefaultValue = function setSearchTableExtraDefaultValue(config) {
  defaultConfig = Object.assign({}, defaultConfig, config);
};
exports.setSearchTableExtraDefaultValue = setSearchTableExtraDefaultValue;
var useFieldsEdit = function useFieldsEdit(tableFields, setTableFields, defaultExtra) {
  var _a = (0, _react.useState)(false),
    visible = _a[0],
    setVisible = _a[1];
  var _b = (0, _react.useState)(
    // @ts-ignore
    tableFields.filter(function (field) {
      // 已经设置过展示的，直接通过判定
      if (field.__extraTouched) {
        return true;
      }
      return !field.hidden;
    }).map(function (field, i) {
      var _a, _b;
      return {
        checked: defaultExtra.includes((_a = field === null || field === void 0 ? void 0 : field.key) !== null && _a !== void 0 ? _a : '') ? false : field.__hidden === false || field.__hidden === undefined,
        title: field.title || '',
        key: field.key || '',
        order: (_b = field.__order) !== null && _b !== void 0 ? _b : i,
        alias: field.__alias || ''
      };
    })),
    normalFields = _b[0],
    setNormalFields = _b[1];
  (0, _react.useEffect)(function () {
    if (defaultExtra && defaultExtra.length) {
      setTimeout(function () {
        handleConfirm();
      }, 800);
    }
    // setTableFields(normalFields)
  }, [defaultExtra]);
  var handleCheckedChange = function handleCheckedChange(i, value) {
    // @ts-ignore
    var newFields = __spreadArray([], normalFields, true);
    var fieldEdit = newFields[i];
    fieldEdit.checked = value;
    setNormalFields(newFields);
  };
  var handleAliasChange = function handleAliasChange(i, value) {
    var newFields = __spreadArray([], normalFields, true);
    var fieldEdit = newFields[i];
    fieldEdit.alias = value || '';
    setNormalFields(newFields);
  };
  /**
   * 向上移动元素位置
   * @param i 当前位置
   */
  var handleMoveUp = function handleMoveUp(i) {
    var _a;
    if (i === 0) {
      return;
    }
    var newFields = __spreadArray([], normalFields, true);
    var current = newFields[i];
    var prev = newFields[i - 1];
    var currentOrder = current.order;
    current.order = prev.order;
    prev.order = currentOrder;
    _a = [newFields[i - 1], newFields[i]], newFields[i] = _a[0], newFields[i - 1] = _a[1];
    setNormalFields(newFields);
  };
  /**
   * 向下移动元素位置
   * @param i 当前位置
   */
  var handleMoveDown = function handleMoveDown(i) {
    var _a;
    if (i === normalFields.length - 1) {
      return;
    }
    var newFields = __spreadArray([], normalFields, true);
    // 赋值 order
    var current = newFields[i];
    var next = newFields[i + 1];
    var currentOrder = current.order;
    current.order = next.order;
    next.order = currentOrder;
    _a = [newFields[i + 1], newFields[i]], newFields[i] = _a[0], newFields[i + 1] = _a[1];
    setNormalFields(newFields);
  };
  /**
   * 确认修改
   */
  var handleConfirm = function handleConfirm() {
    var newFields = __spreadArray([], tableFields, true);
    newFields.filter(function (field) {
      // 已经设置过展示的，直接通过判定
      if (field.__extraTouched) {
        return true;
      }
      return !field.hidden;
    }).forEach(function (field) {
      var target = normalFields.find(function (item) {
        return item.key === field.key;
      });
      if (target) {
        field.__extraTouched = true;
        field.__hidden = !target.checked;
        field.__order = target.order;
        field.__alias = target.alias;
      }
    });
    setTableFields(newFields);
    setVisible(false);
  };
  /**
   *  设置初始选中
   */
  var setDefaultField = function setDefaultField(defaultArray) {
    if (defaultArray === void 0) {
      defaultArray = ['receiptName'];
    }
  };
  return {
    fieldsEdit: /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_MwDialog.default, {
      title: _locale.default.extra.columnSetting,
      visible: visible,
      setVisible: setVisible,
      onConfirm: handleConfirm
    }, normalFields.map(function (fieldEdit, i) {
      return !fieldEdit.hidden && /*#__PURE__*/_react.default.createElement("div", {
        className: "mw-search-table-extra-fields-edit-line",
        key: fieldEdit.key
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "mw-search-table-extra-fields-edit-line-left"
      }, /*#__PURE__*/_react.default.createElement(_antd.Checkbox, {
        defaultChecked: fieldEdit.checked,
        onChange: function onChange(e) {
          return handleCheckedChange(i, e.target.checked);
        }
      }, fieldEdit.title)), /*#__PURE__*/_react.default.createElement("div", {
        className: "mw-search-table-extra-fields-edit-line-right"
      }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
        style: {
          marginRight: 20
        },
        value: fieldEdit.alias,
        placeholder: _locale.default.extra.rename,
        onChange: function onChange(e) {
          return handleAliasChange(i, e.target.value);
        },
        allowClear: true
      }), /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
        title: _locale.default.extra.moveUp,
        placement: "left"
      }, /*#__PURE__*/_react.default.createElement(_MwButton.default, {
        type: "link",
        icon: /*#__PURE__*/_react.default.createElement(_icons.ArrowUpOutlined, null),
        onClick: function onClick() {
          return handleMoveUp(i);
        }
      })), /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
        title: _locale.default.extra.moveDown,
        placement: "right"
      }, /*#__PURE__*/_react.default.createElement(_MwButton.default, {
        type: "link",
        icon: /*#__PURE__*/_react.default.createElement(_icons.ArrowDownOutlined, null),
        onClick: function onClick() {
          return handleMoveDown(i);
        }
      }))));
    })), /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
      title: _locale.default.extra.columnSetting
    }, /*#__PURE__*/_react.default.createElement(_icons.SettingOutlined, {
      onClick: function onClick() {
        return setVisible(true);
      }
    }))),
    setDefaultField: setDefaultField
  };
};
function useExtraBtn(tableRef, searchRef, tableFields, setTableFields, props) {
  // 合并配置
  var config = Object.assign({}, defaultConfig, props);
  var extraVisible = config.extraVisible,
    extraRefreshVisible = config.extraRefreshVisible,
    extraSizeVisible = config.extraSizeVisible,
    extraSizeDefaultValue = config.extraSizeDefaultValue,
    extraSettingVisible = config.extraSettingVisible,
    extraFullscreenVisible = config.extraFullscreenVisible;
  /** 表格尺寸 */
  var _a = (0, _react.useState)(extraSizeDefaultValue),
    size = _a[0],
    setSize = _a[1];
  /** 表格全屏 */
  var _b = (0, _react.useState)(false),
    isEnter = _b[0],
    setIsEnter = _b[1];
  var _c = useFieldsEdit(tableFields, setTableFields, props.defaultExtra || []),
    fieldsEdit = _c.fieldsEdit,
    setDefaultField = _c.setDefaultField;
  var handleRefresh = function handleRefresh() {
    tableRef.current.refresh();
  };
  var handleSizeChange = function handleSizeChange(e) {
    setSize(e.key);
  };
  (0, _react.useEffect)(function () {
    // body 的 style 防止滚动
    if (isEnter) {
      document.body.style.overflow = 'hidden';
    } else {
      document.body.style.overflow = '';
    }
    searchRef.current && searchRef.current.resize();
  }, [isEnter]);
  var extraBtns = extraVisible ? /*#__PURE__*/_react.default.createElement("div", {
    className: "mw-search-table-extra-btns",
    key: "mw-search-table-extra-btns"
  }, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    size: "middle"
  }, extraRefreshVisible ? /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
    title: _locale.default.extra.refresh
  }, /*#__PURE__*/_react.default.createElement(_icons.ReloadOutlined, {
    onClick: handleRefresh
  })) : null, extraSizeVisible ? /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
    title: _locale.default.extra.density
  }, /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
    overlay: /*#__PURE__*/_react.default.createElement(_antd.Menu, {
      style: {
        width: 100
      },
      selectedKeys: [size + ''],
      onClick: handleSizeChange
    }, /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: "large"
    }, _locale.default.extra.densityLarger), /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: "middle"
    }, _locale.default.extra.densityMiddle), /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: "small"
    }, _locale.default.extra.densitySmall))
  }, /*#__PURE__*/_react.default.createElement(_icons.ColumnHeightOutlined, null))) : null, extraSettingVisible ? fieldsEdit : null, extraFullscreenVisible ? isEnter ? /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
    title: _locale.default.extra.exitFullScreen,
    key: _locale.default.extra.exitFullScreen
  }, /*#__PURE__*/_react.default.createElement(_icons.FullscreenExitOutlined, {
    className: "mw-search-table-fullscrenn-enter",
    onClick: function onClick() {
      return setIsEnter(false);
    }
  })) : /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
    title: _locale.default.extra.fullScreen,
    key: _locale.default.extra.fullScreen
  }, /*#__PURE__*/_react.default.createElement(_icons.FullscreenOutlined, {
    className: "mw-search-table-fullscrenn-out",
    onClick: function onClick() {
      return setIsEnter(true);
    }
  })) : null)) : null;
  return {
    extraBtns: extraBtns,
    isEnter: isEnter,
    setIsEnter: setIsEnter,
    size: size,
    setDefaultField: setDefaultField
  };
}