"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useSelection;
var _react = _interopRequireWildcard(require("react"));
var _antd = require("antd");
var _MwAction = _interopRequireDefault(require("../../MwAction"));
var _utils = require("../../utils");
var _locale = _interopRequireDefault(require("../../locale"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __spreadArray = void 0 && (void 0).__spreadArray || function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
};
function useSelection(_props) {
  var rowKey = _props.rowKey,
    selectionType = _props.selectionType,
    onSelectionChange = _props.onSelectionChange,
    selectShowKey = _props.selectShowKey,
    rowSelection = _props.rowSelection;
  var _a = (0, _react.useState)([]),
    selectionKeys = _a[0],
    setSelectionKeys = _a[1];
  var _b = (0, _react.useState)([]),
    selection = _b[0],
    setSelection = _b[1];
  var tableRowSelection;
  if (selectionType) {
    tableRowSelection = __assign(__assign({}, rowSelection), {
      type: selectionType,
      selectedRowKeys: selectionKeys,
      onSelect: function onSelect(record, selected) {
        if (selectionType === 'radio') {
          changeRadioSelection(record);
        } else {
          selected ? addSelection(record) : removeSelection(null, record);
        }
      },
      onSelectAll: function onSelectAll(selected, selectedRows, changeRows) {
        selected ? addSelectionArray(selectedRows) : removeSelectionArray(changeRows);
      }
    });
  }
  /**
   * 清空所有选项
   */
  var clearSelection = function clearSelection() {
    setSelectionKeys([]);
    setSelection([]);
  };
  /**
   * 设置选中的行
   */
  var setDefaultSelection = function setDefaultSelection(selection) {
    setSelection(selection);
    setSelectionKeys(selection.map(function (row) {
      return (0, _utils.getKey)(row, rowKey);
    }));
  };
  /**
   * 添加选项
   */
  var addDefaultSelection = function addDefaultSelection(addSelection) {
    // @ts-ignore
    var newSelection = __spreadArray([], selection, true);
    addSelection.forEach(function (row) {
      if (!selectionKeys.includes((0, _utils.getKey)(row, rowKey))) {
        newSelection.push(row);
      }
    });
    setSelection(newSelection);
    setSelectionKeys(newSelection.map(function (row) {
      return (0, _utils.getKey)(row, rowKey);
    }));
  };
  var changeRadioSelection = function changeRadioSelection(row) {
    var newKeys = [];
    var newSelection = [];
    newKeys.push((0, _utils.getKey)(row, rowKey));
    newSelection.push(row);
    setSelectionKeys(newKeys);
    setSelection(newSelection);
  };
  /**
   * 添加选项（单个）
   * @param row 某一条选项
   */
  var addSelection = function addSelection(row) {
    // @ts-ignore
    var newKeys = __spreadArray([], selectionKeys, true);
    var newSelection = __spreadArray([], selection, true);
    newKeys.push((0, _utils.getKey)(row, rowKey));
    newSelection.push(row);
    setSelectionKeys(newKeys);
    setSelection(newSelection);
  };
  /**
   * 添加选项（数组）
   * @param rows 项目列表
   */
  var addSelectionArray = function addSelectionArray(rows) {
    var newKeys = __spreadArray([], selectionKeys, true);
    var newSelection = __spreadArray([], selection, true);
    rows.forEach(function (row) {
      if (!row) {
        return;
      }
      var key = (0, _utils.getKey)(row, rowKey);
      if (!newKeys.includes(key)) {
        newKeys.push(key);
        newSelection.push(row);
      }
    });
    setSelectionKeys(newKeys);
    setSelection(newSelection);
  };
  /**
   * 移除某个选项
   * @param i 移除选项的 index
   */
  var removeSelection = function removeSelection(i, record) {
    var newKeys = __spreadArray([], selectionKeys, true);
    var newSelection = __spreadArray([], selection, true);
    if (i === null && record) {
      i = newKeys.findIndex(function (key) {
        return key === (0, _utils.getKey)(record, rowKey);
      });
    }
    if (typeof i === 'number') {
      newKeys.splice(i, 1);
      newSelection.splice(i, 1);
    }
    setSelectionKeys(newKeys);
    setSelection(newSelection);
  };
  /**
   * 移除一组选项
   * @param rows 移除选项
   */
  var removeSelectionArray = function removeSelectionArray(rows) {
    var newKeys = __spreadArray([], selectionKeys, true);
    var newSelection = __spreadArray([], selection, true);
    rows.forEach(function (row) {
      var index = newKeys.findIndex(function (item) {
        return item === (0, _utils.getKey)(row, rowKey);
      });
      if (index >= 0) {
        newKeys.splice(index, 1);
        newSelection.splice(index, 1);
      }
    });
    setSelectionKeys(newKeys);
    setSelection(newSelection);
  };
  /** Popover 弹窗的提示 */
  var popContent = /*#__PURE__*/_react.default.createElement("div", {
    className: "mw-search-poper"
  }, selection.map(function (row, i) {
    return /*#__PURE__*/_react.default.createElement(_antd.Tag, {
      key: (0, _utils.getKey)(row, rowKey),
      closable: true,
      className: "mb",
      onClose: function onClose() {
        return removeSelection(i);
      }
    }, row[selectShowKey || 'name']);
  }));
  var message = /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("span", null, _locale.default.table.selectedBefore, /*#__PURE__*/_react.default.createElement(_antd.Popover, {
    title: _locale.default.table.selectedTitle,
    content: popContent
  }, /*#__PURE__*/_react.default.createElement("a", null, selection.length)), "\xA0", _locale.default.table.selectedAfter), /*#__PURE__*/_react.default.createElement(_MwAction.default, {
    className: "ml",
    type: "link",
    size: "small",
    onClick: clearSelection
  }, _locale.default.table.selectedClear));
  /** 头部已选中的提示 */
  var header = selectionKeys.length ? /*#__PURE__*/_react.default.createElement(_antd.Alert, {
    className: "mw-search-table-alert",
    message: message,
    showIcon: true
  }) : '';
  (0, _react.useEffect)(function () {
    if (onSelectionChange) {
      onSelectionChange(selection, selectionKeys);
    }
  }, [onSelectionChange, selection]);
  return {
    header: header,
    message: message,
    tableRowSelection: tableRowSelection,
    selection: selection,
    clearSelection: clearSelection,
    removeSelection: removeSelection,
    setSelection: setDefaultSelection,
    addSelection: addDefaultSelection
  };
}