"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.install = exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _moment = _interopRequireDefault(require("moment"));
var _antd = require("antd");
var _constant = require("../constant");
var _utils = require("../utils");
var _MwSelect = _interopRequireDefault(require("../MwSelect"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var install = function install(registerTableRender) {
  registerTableRender('__options', function (_a) {
    var field = _a.field,
      text = _a.text;
    var option = field.options.find(function (option) {
      return option.value === text;
    });
    return option ? option.label : text;
  });
  registerTableRender('__ellipsis', function (_a) {
    var text = _a.text,
      field = _a.field;
    var type = field.type,
      _b = field.options,
      options = _b === void 0 ? [] : _b;
    var shiftTitle = text;
    if (type === 'select' && options.length) {
      shiftTitle = (0, _utils.getValueByOptions)(text, field.options);
    }
    if (type === 'number' && typeof text === 'number' && !isNaN(text)) {
      shiftTitle = text.toString();
    }
    return /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
      placement: field.placement || 'topLeft',
      title: shiftTitle
    }, /*#__PURE__*/_react.default.createElement("span", null, shiftTitle || ''));
  });
  registerTableRender('datetime', function (_a) {
    var text = _a.text,
      field = _a.field;
    if (!text) {
      return '';
    }
    return (0, _moment.default)(text).format(field.format || 'YYYY-MM-DD HH:mm:ss');
  });
  registerTableRender('editable-cell-input', function (_a) {
    var text = _a.text,
      field = _a.field;
    return function (_a) {
      var editing = _a.editing,
        mode = _a.mode,
        save = _a.save;
      var inputRef = (0, _react.useRef)(null);
      (0, _react.useEffect)(function () {
        if (editing && mode === 'col') {
          inputRef.current.focus();
        }
      }, [editing]);
      return !editing ? text : /*#__PURE__*/_react.default.createElement(_antd.Input, __assign({
        placeholder: "\u8BF7\u8F93\u5165"
      }, field.contentProps, {
        ref: inputRef,
        onBlur: save,
        onPressEnter: save
      }));
    };
  });
  registerTableRender('editable-cell-select', function (_a) {
    var text = _a.text,
      field = _a.field;
    var options = field.options || [];
    var label = '';
    if (Array.isArray(text)) {
      if (!text.length) {
        text = _constant.FORM_READONLY_EMPTY;
      }
      label = text.map(function (item) {
        return (0, _utils.getValueByOptions)(item, field.options);
      }).join(field.splitText || '、');
    } else {
      label = (0, _utils.getValueByOptions)(text, field.options);
    }
    return function (_a) {
      var editing = _a.editing,
        save = _a.save,
        mode = _a.mode;
      var selectRef = (0, _react.useRef)(null);
      (0, _react.useEffect)(function () {
        if (editing && mode === 'col') {
          selectRef.current.focus();
        }
      }, [editing]);
      return !editing ? label : /*#__PURE__*/_react.default.createElement(_MwSelect.default, __assign({
        placeholder: "\u8BF7\u9009\u62E9",
        style: {
          width: '100%'
        }
      }, field.contentProps, {
        ref: selectRef,
        options: options,
        onBlur: save
      }));
    };
  });
  registerTableRender('image', function (_a) {
    var text = _a.text,
      field = _a.field;
    return /*#__PURE__*/_react.default.createElement(_antd.Image, __assign({
      width: 100
    }, field.props, {
      src: text
    }));
  });
  registerTableRender('html', function (_a) {
    var text = _a.text,
      field = _a.field;
    return /*#__PURE__*/_react.default.createElement("div", {
      dangerouslySetInnerHTML: {
        __html: text
      }
    });
  });
  registerTableRender('tags', function (_a) {
    var text = _a.text,
      field = _a.field;
    if (!Array.isArray(text) || !field.colorMap) {
      return text;
    }
    return text.map(function (item) {
      return /*#__PURE__*/_react.default.createElement(_antd.Tag, {
        key: item,
        color: field.colorMap[item]
      }, item);
    });
  });
  registerTableRender('unit', function (_a) {
    var text = _a.text,
      field = _a.field;
    return /*#__PURE__*/_react.default.createElement("div", null, field.prefix, text, field.suffix);
  });
  /**
   * 5
   * @decs 状态加文字
   *
   * @returns ReactNode
   */
  registerTableRender('status', function (_a) {
    var text = _a.text,
      field = _a.field;
    var _b = field.options,
      options = _b === void 0 ? [] : _b;
    return (0, _utils.renderStatus)(text, options, field.type);
  });
};
exports.install = install;
var _default = {
  install: install
};
exports.default = _default;