"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setLanguage = exports.isJP = exports.default = exports.activeLang = void 0;
var _zh_CN = _interopRequireDefault(require("./zh_CN"));
var _en_US = _interopRequireDefault(require("./en_US"));
var _ja_JP = _interopRequireDefault(require("./ja_JP"));
var _ko_KR = _interopRequireDefault(require("./ko_KR"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var activeLang = localStorage.getItem('MULTIWAY_LOCALE') || 'zh_CN';
exports.activeLang = activeLang;
var langMap = {
  zh_CN: _zh_CN.default,
  en_US: _en_US.default,
  ja_JP: _ja_JP.default,
  ko_KR: _ko_KR.default
};
var isJP = function isJP() {
  return activeLang === 'ja_JP';
};
/** 设置语言 */
exports.isJP = isJP;
var setLanguage = function setLanguage(lang) {
  exports.activeLang = activeLang = lang;
  localStorage.setItem('MULTIWAY_LOCALE', lang);
};
exports.setLanguage = setLanguage;
var _default = langMap[activeLang];
exports.default = _default;